package dialogs;

import javax.swing.JOptionPane;
import main.*;
public class EventDialog extends JOptionPane{
	public static int NULL =0;
	public static int INJURY = 1;
	public static int SUSPENSION =2;
	public static int FNAMECHANGE = 3;
	public static int LNAMECHANGE =4;
	public static int POSCHANGE = 5;
	public static int PLAYAGAIN = 6;
	public static int SUSPENSION_VIOLATION = 7;
	public static String[] POS = {"-", "PG", "SG", "SF", "PF", "C"};
	public static String[] FEMALENAMES = {"Anna", "Lisa", "Maria", "Linda", "Deborah", 
		"Emily", "Emma", "Madison", "Isabella", "Eva", 
		"Olivia", "Hannah", "Samantha", "Sophia", "Sarah", 
		"Ashley", "Jennifer", "Elizabeth", "Megan", "Amanda", "Rebecca", 
		"Amber", "Michelle", "Tiffany", "Lauren"};
	
	public static String[] BODYPARTS = {"knee", "back", "hamstring", "quadricepz", "shoulder", "foot",
		"elbow", "groin", "index finger", "thumb", "hand", "knee" };
	
	public static String[] CRIME = {"being involved in a shooting", "getting caught with dope", 
		"beating up a man in a nightclub", "carrying a loaded handgun at the airport", "betting on games of his team", 
		"driving drunk", "insulting a police officer", "not wearing a business suit before the match"};
	
	public static void showEvent(int event, Player player, GameMain parent, int duration) {
		if (event != NULL) {
		String message = "";
			String title = "";
			if (event == INJURY) {
				String bodytype = BODYPARTS[(int)(BODYPARTS.length*Math.random())];
				message = "Your Player "+player.firstname+ " "+player.lastname+" suffered a \n"+bodytype+" injury and will miss "+duration+" games." ;
				title = "Injury :(";
			}
			if (event == SUSPENSION) {
				String crime = CRIME[(int)(CRIME.length*Math.random())];
				message = "Your Player "+player.firstname+ " "+player.lastname+" proved his \nstreet cred by "+crime+". \nThe league suspends him for "+duration+" games." ;
				
				title = "Suspension";
			}
			if (event == FNAMECHANGE) {
				String fname = Player.randomPlayer().firstname;
				message = "Your Player "+player.firstname+ " "+player.lastname+" decided \nto change his name to "+fname+".\nSounds cool, doesn't it?";
				player.firstname = fname;
				title = "Who is "+fname+"?";
			}
			if (event == LNAMECHANGE) {
				String lname = Player.randomPlayer().lastname;
				String fname = FEMALENAMES[(int)(FEMALENAMES.length*Math.random())];
				message = "Your Player "+player.firstname+ " "+player.lastname+" married \nhis girlfriend "+fname+" and decided to take her family name. \n. So you can call him "+player.firstname+" "+lname +" now.";
				player.lastname = lname;
				title = player.firstname+" "+lname;
			}
			if (event == POSCHANGE) {
				message = "Your Player "+player.firstname+ " "+player.lastname+" decided \nhe feels much more like a "+POS[player.position]+".\nHe will just play that position from now on.";
				
				title = player.firstname+ " "+player.lastname+" the "+POS[player.position];
			}
			if (event ==PLAYAGAIN) {
				message = "Your Player "+player.firstname+ " "+player.lastname+" may play again next game.";
				player.special_status=0;
				player.special_duration=0;
				
				title = player.firstname+ " "+player.lastname+" is back!";
			
			}
			if (event ==SUSPENSION_VIOLATION) {
				message = "Your Player "+player.firstname+ " "+player.lastname+" was not allowed to play! \nYou are fined $500 by the league.";

				player.special_duration++;
				parent.team.credits -=500;
				title = player.firstname+ " "+player.lastname+" was not allowed to play!";
			
			}
			
			
			showMessageDialog(parent, message, title, JOptionPane.INFORMATION_MESSAGE); 
		}
	}
	
	public static void generateEvent(GameMain parent) {
		int event = NULL;
		int duration =0;
		int rnd = (int)(Math.random()*250);
		int playerid = (int)(Math.random()*15); 
		Player p =parent.team.players[playerid]; 
		if (rnd <80 && p.real() ) {
			if (p.special_status==0) {
				event = INJURY;
				
				duration = (int)(Math.random()*10)+1;
				p.special_status = INJURY;
				p.special_duration=duration;
			}
		}
		else if (rnd<110 && p.real()) {
			if (p.special_status==0) {
				event = SUSPENSION;
				duration = (int)(Math.random()*10)+1;
				p.special_status = SUSPENSION;
				p.special_duration=duration;
			}
		}
		else if (rnd<116 && p.real()) {
			event = FNAMECHANGE;
		}
		else if (rnd<121 && p.real()) {
			event = LNAMECHANGE;
		}
		else if (rnd<130 && p.real()) {
			int newpos = (int)(Math.random()*5)+1;
			if (newpos!= p.position) {
				event = POSCHANGE;
				p.position = newpos;	
			}
			
		}
		
		
		
		
		showEvent(event, p, parent, duration);
	}
	
}
