package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import main.*;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class GameAfterMatch extends JPanel{
	private GameAfterMatch window;
	private JTextField filename;
	private JTextField teamname;
	private Team team;
	private Team opponent;
	private JLabel[][] players;
	private JLabel[][] oplayers;
	private GameMain _main;
	private BoxScore boxscore;
	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color red = new Color(255,0,0);
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	
	private String[] positions = { "PG", "SG", "SF", "PF", "C", "pg", "sg", "sf", "pf", "c", "11", "12", "13", "14", "15" };

	
	public GameAfterMatch(GameMain main, Team op) {
		super();
		_main=main;
		opponent=op;
		this.team = _main.team;
		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);
		boxscore=new BoxScore(team, opponent,true);
		boxscore.updateStats();
		boxscore.updateValues(1);
		for (int i=0;i<15;i++) {
			Player  p = _main.team.players[i];
			if (p.real()) {
				if (p.special_duration > 0) p.special_duration--;
				if (p.special_status !=0 && p.special_duration <=0) {
					EventDialog.showEvent(EventDialog.PLAYAGAIN, p, _main, 0);
				}
				if (p.special_status == EventDialog.SUSPENSION && i <10) {
					EventDialog.showEvent(EventDialog.SUSPENSION_VIOLATION, p, _main, 0);
				}
				if (p.confidence<1) {
					int rnd = (int)(Math.random()*4);
					if (rnd==0 && p.skill_scoring>1){
						p.skill_scoring--;
						InfoDialog.message(p.firstname +" "+ p.lastname +" lost all of his confidence. \n Therefore, his scoring-skill decreased. To prevent players from losing their confidence, let them play!\n", p.lastname+" scoring: "+(p.skill_scoring+1)+" -->"+p.skill_scoring, _main);
					}
					if (rnd==1 && p.skill_passing>1){
						p.skill_passing--;
						InfoDialog.message(p.firstname +" "+ p.lastname +" lost all of his confidence. \n Therefore, his passing-skill decreased. To prevent players from losing their confidence, let them play!\n", p.lastname+" passing: "+(p.skill_passing+1)+" -->"+p.skill_passing, _main);
					}
					if (rnd==2 && p.skill_rebounds>1){
						p.skill_rebounds--;
						InfoDialog.message(p.firstname +" "+ p.lastname +" lost all of his confidence. \n Therefore, his rebounds-skill decreased. To prevent players from losing their confidence, let them play!\n", p.lastname+" rebounds: "+(p.skill_rebounds+1)+" -->"+p.skill_rebounds, _main);
					}
					if (rnd==3 && p.skill_defense>1){
						p.skill_defense--;
						InfoDialog.message(p.firstname +" "+ p.lastname +" lost all of his confidence. \n Therefore, his defense-skill decreased. To prevent players from losing their confidence, let them play!\n", p.lastname+" defense: "+(p.skill_defense+1)+" -->"+p.skill_defense, _main);
					}
					p.confidence =10;
				}
				if (p.energy<1) {
					int rnd = (int)(Math.random()*4);
					if (rnd==0 && p.skill_scoring>1){
						p.skill_scoring--;
						InfoDialog.message(p.firstname +" "+ p.lastname +" needed to skip training this week because of fatigue. \n His scoring-skill decreased to "+p.skill_scoring+". To prevent exhaustion, \n give your stars some pause from time to time! \n", p.lastname+" scoring: "+(p.skill_scoring+1)+" -->"+p.skill_scoring, _main);
					}
					if (rnd==1 && p.skill_passing>1){
						p.skill_passing--;
						InfoDialog.message(p.firstname +" "+ p.lastname +" needed to skip training this week because of fatigue. \n His passing-skill decreased to "+p.skill_passing+". To prevent exhaustion, \n give your stars some pause from time to time!\n", p.lastname+" passing: "+(p.skill_passing+1)+" -->"+p.skill_passing, _main);
						}
					if (rnd==2 && p.skill_rebounds>1){
						p.skill_rebounds--;
						InfoDialog.message(p.firstname +" "+ p.lastname +" needed to skip training this week because of fatigue. \n  Therefore, his rebounds-skill decreased. \n  To prevent exhaustion, give your stars some pause from time to time!\n", p.lastname+" rebounds: "+(p.skill_rebounds+1)+" -->"+p.skill_rebounds, _main);
						}
					if (rnd==3 && p.skill_defense>1){
						p.skill_defense--;
						InfoDialog.message(p.firstname +" "+ p.lastname +" needed to skip training this week because of fatigue. \n Therefore, his defense-skill decreased. \n To prevent exhaustion, give your stars some pause from time to time!\n", p.lastname+" defense: "+(p.skill_defense+1)+" -->"+p.skill_defense, _main);
						}
					p.energy =15;
				}
				
				if (p.energy > 19 && p.confidence>49) {
					UpgradeChooser ugc = new UpgradeChooser(p);
					ugc.setAlwaysOnTop(true);
					p.confidence=7;
					p.energy = 7;
				}
				
			}
		}
		EventDialog.generateEvent(_main);
		showDialog(team);
		_main.nextGame();

	}
	private void showDialog(Team team){
		window=this;

		
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		
		
		c.fill = GridBagConstraints.BOTH;
		int i = 0;
		JLabel desc = new JLabel(team.name+"    ");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		desc= new JLabel(""+boxscore.getPoints_Team1());
		c.gridx = 1; c.gridy = i; this.add(desc, c);
		i++;
		
		desc = new JLabel("Position  ");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		desc= new JLabel("Name");
		c.gridx = 1; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = 3; c.gridy = i; this.add(desc, c);
		desc= new JLabel("PTS ");
		c.gridx = 4; c.gridy = i; this.add(desc, c);
		desc= new JLabel("REB");
		c.gridx = 5; c.gridy = i; this.add(desc, c);
		desc= new JLabel("AST");
		c.gridx = 6; c.gridy = i; this.add(desc, c);
		
		
		
		i++;
		
		
		for (int j=0;j<10;j++){
			
			desc = new JLabel(positions[j]);
			c.gridx = 0; c.gridy = i; this.add(desc, c);
			desc=  new JLabel(team.players[j].lastname.toUpperCase()+" "+team.players[j].firstname);
			c.gridx = 1; c.gridy = i; this.add(desc, c);
			desc= new JLabel("  |  ");
			c.gridx = 3; c.gridy = i; this.add(desc, c);
			desc= new JLabel(boxscore.points1[j]+"");
			c.gridx = 4; c.gridy = i; this.add(desc, c);
			desc= new JLabel(boxscore.rebounds1[j]+"");
			c.gridx = 5; c.gridy = i; this.add(desc, c);
			desc= new JLabel(boxscore.assists1[j]+"");
			c.gridx = 6; c.gridy = i; this.add(desc, c);
			
			i++;

		}
		
		i = 0;
		int m =8;
		desc = new JLabel("       ");
		c.gridx = m-1; c.gridy = i; this.add(desc, c);
		desc = new JLabel(opponent.name+"    ");
		c.gridx = m+0; c.gridy = i; this.add(desc, c);
		desc= new JLabel(""+boxscore.getPoints_Team2());
		c.gridx = m+1; c.gridy = i; this.add(desc, c);
		i++;
		
		desc = new JLabel("Position  ");
		c.gridx = m+0; c.gridy = i; this.add(desc, c);
		desc= new JLabel("Name");
		c.gridx = m+1; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = m+3; c.gridy = i; this.add(desc, c);
		desc= new JLabel("PTS ");
		c.gridx = m+4; c.gridy = i; this.add(desc, c);
		desc= new JLabel("REB");
		c.gridx = m+5; c.gridy = i; this.add(desc, c);
		desc= new JLabel("AST");
		c.gridx = m+6; c.gridy = i; this.add(desc, c);
		
		i++;
		
		for (int j=0;j<10;j++){
			
			desc = new JLabel(positions[j]);
			c.gridx = m+0; c.gridy = i; this.add(desc, c);
			desc=  new JLabel(opponent.players[j].lastname.toUpperCase()+" "+opponent.players[j].firstname);
			c.gridx = m+1; c.gridy = i; this.add(desc, c);
			desc= new JLabel("  |  ");
			c.gridx = m+3; c.gridy = i; this.add(desc, c);
			desc= new JLabel(boxscore.points2[j]+"");
			c.gridx = m+4; c.gridy = i; this.add(desc, c);
			desc= new JLabel(boxscore.rebounds2[j]+"");
			c.gridx = m+5; c.gridy = i; this.add(desc, c);
			desc= new JLabel(boxscore.assists2[j]+"");
			c.gridx = m+6; c.gridy = i; this.add(desc, c);
			
			i++;

		}
	
		this.setVisible(true);
	}


}
