package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import main.*;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class GameAfterRS extends JPanel{

	private GameMain _main;

	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color red = new Color(255,0,0);
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	
	
	public GameAfterRS(GameMain main) {
		super();
		_main=main;
		
		
		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);


		
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		
		c.fill = GridBagConstraints.BOTH;	
		
		int n= main.league.conference_numbers;
		int m = main.league.teams_conference.length;

		List[] division_standings = new List[n];
		for (int i=0; i<n;i++) {
			int counter=0;
			int k=0;
			for (int j=0; j<m;j++) {
				if (main.league.teams_conference[j]==i) counter++;
			}
			Object[] data = new Team[counter];
			
			for (int j=0;j<counter;j++){
				
				while (true) {
					if (main.league.teams_conference[k]==i) {
						if (k ==0) data[j] = _main.team; 
						else data[j] = _main.opponents[k-1];
						k++;
						break;
					}
					k++;
				}
				
			}
			List list = Arrays.asList(data);

			Collections.sort(list);
			division_standings[i] = list;

				
				
			
			
		}
		


		JPanel jp = new JPanel();
		
		c.gridx = 0; c.gridy = 0; this.add(jp, c);
		GridBagLayout gridbag2=new GridBagLayout();
		jp.setLayout(gridbag2);
		GridLayout layout2 = new GridLayout();
		GridBagConstraints c2 = new GridBagConstraints();
		
		
		JLabel desc = new JLabel("End of regular season");
		desc.setFont(new Font(null, Font.PLAIN, 18));
		c2.gridx = 0; c2.gridy = 0; jp.add(desc, c2);
		for (int i=0;i<division_standings.length;i++) {

			desc = new JLabel(_main.league.conference_names[i]);
			desc.setFont(new Font(null, Font.PLAIN, 18));
			c2.gridx = 3*i; c2.gridy = 1; jp.add(desc, c2);
			List list = division_standings[i];
			for (int j=0;j<list.size();j++) {
				Team o = (Team)list.get(j);
				desc = new JLabel(o.name);
				if (j< _main.league.playoff_teams_par_conference) {
					desc.setForeground(green);
				}
				else {
					desc.setForeground(orange);
				}
				
				if (o==_main.team) {
					desc.setForeground(new Color(0, 80, 120));
				}
				c2.gridx = 3*i +0; c2.gridy = j+2; jp.add(desc, c2);
				desc = new JLabel("  "+o.games_won+"  ");
				if (j< _main.league.playoff_teams_par_conference) {
					desc.setForeground(green);
				}
				else {
					desc.setForeground(orange);
				}
				c2.gridx = 3*i+1; c2.gridy = j+2; jp.add(desc, c2);
				desc = new JLabel("  "+o.games_lost+"         ");
				if (j< _main.league.playoff_teams_par_conference) {
					desc.setForeground(green);
				}
				else {
					desc.setForeground(orange);
				}
				c2.gridx = 3*i+2; c2.gridy = j+2; jp.add(desc, c2);
				
			}
		}
		
		calculatestuff();
		JPanel jp2 = new JPanel();
		c.gridx = 0; c.gridy = 1; this.add(jp2, c);
		GridBagLayout gridbag3=new GridBagLayout();
		jp2.setLayout(gridbag3);
		GridBagConstraints c3 = new GridBagConstraints();

		
	}
	private void calculatestuff() {

		//calculate stuff:
		_main.matchonday = 0;
		DraftPick.calculatePicks(_main);
		_main.season_phase = Game.SEASON_PLAYOFFS;
		_main.po_round = 1;
		_main.league.generatePlayoffs(_main);
		_main.team.resetStats();
		for (int i = 0;i< _main.opponents.length;i++) {
			_main.opponents[i].resetStats();
		}
		_main.nextGame();
	}


}
