package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

import main.*;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class GameBeforeMatch extends JPanel{
	private static int C = 5;
	private static int PF = 4;
	private static int SF = 3;
	private static int SG = 2;
	private static int PG = 1;
	private static int C2 = 10;
	private static int PF2 = 9;
	private static int SF2 = 8;
	private static int SG2 = 7;
	private static int PG2 = 6;
	private GameBeforeMatch window;
	private JTextField filename;
	private JTextField teamname;
	private Team team;
	private Team opponent;
	private JLabel[][] players;
	private JLabel[][] oplayers;
	private GameMain _main;
	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color red = new Color(255,0,0);
	private static Color blue = new Color(0,0,200);
	private static Color cyan = new Color(0,200,200);
	private static Color black = new Color(0,0,0);
	
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	
	private String[] positions = {"-", "PG", "SG", "SF", "PF", "C", "pg", "sg", "sf", "pf", "c", "11", "12", "13", "14", "15" };

	
	public GameBeforeMatch(GameMain main) {
		super();
		_main=main;
			
		opponent=_main.nextopponent;
		this.team = _main.team;
		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);
		showDialog(team);
	}
	private void showDialog(Team team){
		window=this;

		
		initiate();
		
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		
		
		c.fill = GridBagConstraints.BOTH;
		int i = 0;
		JLabel desc = new JLabel("");
		desc.setFont(smaller);
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		desc= new JLabel(team.name);
		c.gridx = 1; c.gridy = i; this.add(desc, c);
		i++;
		
		Font italic = desc.getFont().deriveFont(Font.ITALIC);
		desc = new JLabel("Position  ");
		
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		desc= new JLabel("Name");
		c.gridx = 1; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = 3; c.gridy = i; this.add(desc, c);
		desc= new JLabel("sco.");
		c.gridx = 4; c.gridy = i; this.add(desc, c);
		desc= new JLabel("pas.");
		c.gridx = 5; c.gridy = i; this.add(desc, c);
		desc= new JLabel("reb.");
		c.gridx = 6; c.gridy = i; this.add(desc, c);
		desc= new JLabel("def.");
		c.gridx = 7; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = 8; c.gridy = i; this.add(desc, c);
		desc= new JLabel("NRG  ");
		c.gridx = 9; c.gridy = i; this.add(desc, c);
		desc= new JLabel("CON  ");
		c.gridx = 10; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = 11; c.gridy = i; this.add(desc, c);
		desc= new JLabel("pos");
		c.gridx = 12; c.gridy = i; this.add(desc, c);
		desc= new JLabel("move to");
		c.gridx = 13; c.gridy = i; this.add(desc, c);
		
		
		i++;
		
		
		for (int j=0;j<10;j++){
			
			c.gridx = 0; c.gridy = i; this.add(players[j][0], c);
			c.gridx = 1; c.gridy = i; this.add(players[j][1], c);
			desc= new JLabel("  |  ");
			c.gridx = 3; c.gridy = i; this.add(desc, c);
			c.gridx = 4; c.gridy = i; this.add(players[j][3], c);
			c.gridx = 5; c.gridy = i; this.add(players[j][4], c);
			c.gridx = 6; c.gridy = i; this.add(players[j][5], c);
			c.gridx = 7; c.gridy = i; this.add(players[j][6], c);
			desc= new JLabel("  |  ");
			c.gridx = 8; c.gridy = i; this.add(desc, c);
			c.gridx = 9; c.gridy = i; this.add(players[j][8], c);
			c.gridx = 10; c.gridy = i; this.add(players[j][9], c);
			
			desc= new JLabel("  |  ");
			c.gridx = 11; c.gridy = i; this.add(desc, c);
			c.gridx = 12; c.gridy = i; this.add(players[j][7], c);
			
			JComboBox position_combo = new JComboBox(positions);
			
			position_combo.addActionListener(positionListener);
			position_combo.setName(""+j);
			c.gridx = 13; c.gridy = i; this.add(position_combo, c);
			
			
			i++;

		}
		
		i = 0;
		int m =15;
		
		JButton play = new JButton("Start");
		play.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				_main.mainpanel.removeAll();
				_main.mainpanel.add(new GameAfterMatch(_main, opponent));
				_main.repaint();
			}
		});
		c.gridx = m-1; c.gridy = i; this.add(play, c);
		 
		desc= new JLabel(opponent.name);
		c.gridx = m+ 1; c.gridy = i; this.add(desc, c);
		i++;
		desc = new JLabel("Position");
		
		c.gridx = m+ 0; c.gridy = i; this.add(desc, c);
		desc= new JLabel("Name");
		c.gridx = m+ 1; c.gridy = i; this.add(desc, c);

		desc= new JLabel("  |  ");
		c.gridx = m+ 3; c.gridy = i; this.add(desc, c);
		desc= new JLabel("sco.");
		c.gridx = m+ 4; c.gridy = i; this.add(desc, c);
		desc= new JLabel("pas.");
		c.gridx = m+ 5; c.gridy = i; this.add(desc, c);
		desc= new JLabel("reb.");
		c.gridx = m+ 6; c.gridy = i; this.add(desc, c);
		desc= new JLabel("def.");
		c.gridx = m+ 7; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = m+ 8; c.gridy = i; this.add(desc, c);

		
		i++;
		
		for (int j=0;j<10;j++){
			
			c.gridx = m+0; c.gridy = i; this.add(oplayers[j][0], c);
			c.gridx = m +1; c.gridy = i; this.add(oplayers[j][1], c);
			desc= new JLabel("  |  ");
			c.gridx = m +3; c.gridy = i; this.add(desc, c);
			c.gridx = m +4; c.gridy = i; this.add(oplayers[j][3], c);
			c.gridx = m +5; c.gridy = i; this.add(oplayers[j][4], c);
			c.gridx = m +6; c.gridy = i; this.add(oplayers[j][5], c);
			c.gridx = m +7; c.gridy = i; this.add(oplayers[j][6], c);
			desc= new JLabel("  |  ");
			c.gridx = m +8; c.gridy = i; this.add(desc, c);
						
			i++;

		}
	
		this.setVisible(true);
	}
	
	private ActionListener saveListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			team.filename = filename.getText();
			team.name = teamname.getText();
			team.save();
		}
		
	};
	private void initiate() {
		players = new JLabel[10][10];
		
		for (int j=0;j<10;j++) {
			players[j][0]= new JLabel(positions[j+1]);
			players[j][1]= new JLabel(team.players[j].lastname.toUpperCase()+" "+team.players[j].firstname);
			players[j][2]= new JLabel(String.valueOf(team.players[j].age));		
			players[j][3]= new JLabel(String.valueOf(team.players[j].skill_scoring));
			players[j][4]= new JLabel(String.valueOf(team.players[j].skill_passing));
			players[j][5]= new JLabel(String.valueOf(team.players[j].skill_rebounds));
			players[j][6]= new JLabel(String.valueOf(team.players[j].skill_defense));
			if (team.players[j].position>0) players[j][7]= new JLabel(positions[team.players[j].position]);
			else players[j][7]= new JLabel("-");
			if (j < 10 && team.players[j].position>0) {
				if (team.players[j].position!= j+1 &&team.players[j].position!= j-4) {
					players[j][7].setForeground(orange);
					if ((((j+1 == C) || (j+1 == C2) )&& (team.players[j].position != PF)) ||
							(((j+1 == PF) || (j+1 == PF2) )&& (team.players[j].position != SF && team.players[j].position != C)) ||
							(((j+1 == SF) || (j+1 == SF2) )&& (team.players[j].position != SG && team.players[j].position != PF)) ||
							(((j+1 == SG) || (j+1 == SG2) )&& (team.players[j].position != PG && team.players[j].position != SF)) ||
							(((j+1 == PG) || (j+1 == PG2) )&& (team.players[j].position != SG))) { 
						players[j][7].setForeground(red);
					}
						
				}
				else players[j][7].setForeground(green);
			}
			players[j][8]= new JLabel(String.valueOf(team.players[j].energy));
			players[j][9]= new JLabel(String.valueOf(team.players[j].confidence));
			if (!team.players[j].real()) players[j][8].setText(" ");
			else if (team.players[j].energy < 5) players[j][8].setForeground(red);
			else if (team.players[j].energy < 10) players[j][8].setForeground(orange);
			else if (team.players[j].energy < 20) players[j][8].setForeground(blue);
			else players[j][8].setForeground(green);
			if (!team.players[j].real()) players[j][9].setText(" ");
			else if (team.players[j].confidence < 5) players[j][9].setForeground(red);
			else if (team.players[j].confidence < 10) players[j][9].setForeground(orange);
			else if (team.players[j].confidence< 20) players[j][9].setForeground(blue);
			else if (team.players[j].confidence< 50) players[j][9].setForeground(cyan);
			else players[j][9].setForeground(green);
			players[j][1].setForeground(black);
			if (team.players[j].special_status != 0) players[j][1].setForeground(red);
		
		}
		oplayers = new JLabel[10][7];
		
		for (int j=0;j<10;j++) {
			oplayers[j][0]= new JLabel(positions[j+1]);
			oplayers[j][1]= new JLabel(opponent.players[j].lastname.toUpperCase()+" "+opponent.players[j].firstname);
			oplayers[j][2]= new JLabel(String.valueOf(opponent.players[j].age));		
			oplayers[j][3]= new JLabel(String.valueOf(opponent.players[j].skill_scoring));
			oplayers[j][4]= new JLabel(String.valueOf(opponent.players[j].skill_passing));
			oplayers[j][5]= new JLabel(String.valueOf(opponent.players[j].skill_rebounds));
			oplayers[j][6]= new JLabel(String.valueOf(opponent.players[j].skill_defense));
			
			
		}
		for (int i=0;i<10;i++) {
			for (int j=0;j<8;j++){
				players[i][j].setFont(smaller);
			}
			for (int j=0;j<7;j++){
				oplayers[i][j].setFont(smaller);
			}
		
		}
	}
	private void update() {

		
	 	for (int j=0;j<10;j++) {

			players[j][0].setText(positions[j+1]);
			players[j][1].setText(team.players[j].lastname.toUpperCase()+" "+team.players[j].firstname);
			players[j][2].setText(String.valueOf(team.players[j].age));		
			players[j][3].setText(String.valueOf(team.players[j].skill_scoring));
			players[j][4].setText(String.valueOf(team.players[j].skill_passing));
			players[j][5].setText(String.valueOf(team.players[j].skill_rebounds));
			players[j][6].setText(String.valueOf(team.players[j].skill_defense));
			if (team.players[j].position>0) players[j][7].setText(positions[team.players[j].position]);
			else players[j][7].setText("-");
			if (j < 10 && team.players[j].position>0) {
				if (team.players[j].position!= j+1 &&team.players[j].position!= j-4) {
					players[j][7].setForeground(orange);
					if ((((j+1 == C) || (j+1 == C2) )&& (team.players[j].position != PF)) ||
							(((j+1 == PF) || (j+1 == PF2) )&& (team.players[j].position != SF && team.players[j].position != C)) ||
							(((j+1 == SF) || (j+1 == SF2) )&& (team.players[j].position != SG && team.players[j].position != PF)) ||
							(((j+1 == SG) || (j+1 == SG2) )&& (team.players[j].position != PG && team.players[j].position != SF)) ||
							(((j+1 == PG) || (j+1 == PG2) )&& (team.players[j].position != SG))) { 
						players[j][7].setForeground(red);
					}
						
				}
				else players[j][7].setForeground(green);
			}
			players[j][8].setText(String.valueOf(team.players[j].energy));
			players[j][9].setText(String.valueOf(team.players[j].confidence));
			if (!team.players[j].real()) players[j][8].setText(" ");
			else if (team.players[j].energy < 5) players[j][8].setForeground(red);
			else if (team.players[j].energy < 10) players[j][8].setForeground(orange);
			else if (team.players[j].energy < 20) players[j][8].setForeground(blue);
			else players[j][8].setForeground(green);
			if (!team.players[j].real()) players[j][9].setText(" ");
			else if (team.players[j].confidence < 5) players[j][9].setForeground(red);
			else if (team.players[j].confidence < 10) players[j][9].setForeground(orange);
			else if (team.players[j].confidence< 20) players[j][9].setForeground(blue);
			else players[j][9].setForeground(green);
			players[j][1].setForeground(black);
			if (team.players[j].special_status != 0) players[j][1].setForeground(red);
		
		}
	}
	

	
	private ActionListener positionListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int i = ((JComboBox)e.getSource()).getSelectedIndex()-1;
			int j = Integer.parseInt(((JComboBox)e.getSource()).getName());
			if (i>=0) {
				Player tmpplayer = team.players[i];
				team.players[i] = team.players[j];
				team.players[j] = tmpplayer;
				String tmpname = team.playerfiles[i];
				team.playerfiles[i] = team.playerfiles[j];
				team.playerfiles[j] = tmpname;
				((JComboBox)e.getSource()).setSelectedIndex(0);
				window.update();
			}
			
		}
	};
	
}
