package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import main.*;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class GameContracts extends JPanel{
	private GameContracts window;

	private GameMain _main;
	private Player[] players;
	private int[] salary;
	private JButton[] button;
	private JButton[] waivebutton;
	private JComboBox[] combobox;
	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color red = new Color(255,0,0);
	private static Color blue = new Color(0,0,200);
	
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	private static Font bigger = new Font("SansSerif", Font.PLAIN, 18);
	
	private String[] positions = { "-","PG", "SG", "SF", "PF", "C"};

	
	public GameContracts(GameMain main) {
		super();
		_main=main;
		players = _main.team.players;
		button = new JButton[15];
		waivebutton = new JButton[15];
		salary = new int[15];
		combobox = new JComboBox [15];
		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);


		showDialog();
	}
	private void showDialog(){
		window=this;

		
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		
		
		
		c.fill = GridBagConstraints.BOTH;

		JLabel desc = new JLabel("Contracts");
		desc.setFont(bigger);
		desc.setForeground(blue);
		c.gridx = 1; c.gridy = 0; this.add(desc, c);


		
		desc = new JLabel("Position  ");
		c.gridx = 0; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("Name");
		c.gridx = 1; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("  Age  ");
		c.gridx = 2; c.gridy = 1; this.add(desc, c);
		desc= new JLabel(" Season ");
		c.gridx = 3; c.gridy = 1; this.add(desc, c);
		
		desc= new JLabel("  |   ");
		c.gridx = 9; c.gridy = 1; this.add(desc, c);
		desc= new JLabel(" years left ");
		c.gridx = 10; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("  wave   ");
		c.gridx = 11; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("  contract extension ");
		c.gridx = 12; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("   sign  ");
		c.gridx = 13; c.gridy = 1; this.add(desc, c);
		

		
		for (int i=0;i<players.length;i++){
			salary[i] = players[i].calculateSalary();
			desc = new JLabel(positions[players[i].position]);
			c.gridx = 0; c.gridy = i+2; this.add(desc, c);
			desc = new JLabel(players[i].firstname+" "+players[i].lastname);
			c.gridx = 1; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(players[i].age+"");
			c.gridx = 2; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(players[i].seasons+"");
			c.gridx = 3; c.gridy = i+2; this.add(desc, c);
			
			desc= new JLabel("  |   ");
			c.gridx = 9; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(players[i].seasons_left_contract+"");
			if (players[i].seasons_left_contract==1) desc.setForeground(orange);
			else if (players[i].seasons_left_contract==0) desc.setForeground(red);
			c.gridx = 10; c.gridy = i+2; this.add(desc, c);
			
			waivebutton[i] = new JButton("waive");
			if (!players[i].real()) waivebutton[i].setEnabled(false);
			waivebutton[i].setName(i+"");
			waivebutton[i].setForeground(red);
			waivebutton[i].addActionListener(waiveListener);
			c.gridx = 11; c.gridy = i+2; this.add(waivebutton[i], c);
			String[] options = new String[5];
			for (int j=0;j<5;j++) {
				options[j] = (j+1)+" years: "+(j+1)*salary[i]+" $";
			}
			combobox[i] = new JComboBox(options);
			combobox[i].addActionListener(comboListener);
			combobox[i].setName(i+"");
			if (!players[i].real()) combobox[i].setEnabled(false); 
			c.gridx = 12; c.gridy = i+2; this.add(combobox[i], c);
			button[i] = new JButton("Resign");
			if (!players[i].real() || salary[i] > _main.team.credits) button[i].setEnabled(false);
			else button[i].setForeground(blue);
			button[i].setName(i+"");
			
			button[i].addActionListener(signListener);
			c.gridx = 13; c.gridy = i+2; this.add(button[i], c);
		}
		
		this.setVisible(true);
	}
	private ActionListener comboListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int id = Integer.parseInt(((JComboBox)e.getSource()).getName());
			int i = ((JComboBox)e.getSource()).getSelectedIndex()+1;
			
			if (i*salary[id] > _main.team.credits) {
				button[id].setEnabled(false);
			}
			else{
				button[id].setEnabled(true);
				button[id].setForeground(blue);
			}
			 
		}
	};
	private ActionListener signListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int id = Integer.parseInt(((JButton)e.getSource()).getName());
			int duration =(combobox[id].getSelectedIndex()+1);
			_main.team.credits = _main.team.credits -(duration*salary[id]);
			players[id].seasons_left_contract += duration;
			_main.mainpanel.removeAll();
			_main.mainpanel.add(new GameContracts(_main));
			_main.repaint();
		}
	};
	private ActionListener waiveListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int id = Integer.parseInt(((JButton)e.getSource()).getName());
			Player p = players[id];
			String txt = "Do you really want to waive \n "+p.firstname+" "+p.lastname+"?";
			int feedback = JOptionPane.showConfirmDialog(_main, txt, "Waive "+p.firstname+ " "+p.lastname, JOptionPane.YES_NO_OPTION);
			if (feedback==JOptionPane.YES_OPTION) {
				_main.league.addFA(p);
				_main.team.players[id] = new Player();
			}
			else {

			}
			_main.mainpanel.removeAll();
			_main.mainpanel.add(new GameContracts(_main));
			_main.repaint();
		}
	};
}
