package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import main.*;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

public class GameDraft extends JPanel{

	private GameMain _main;

	private static Color orange = new Color(200,150,0);
	private static Color green = new Color(0,200,0);
	private static Color blue= new Color(0,0,200);
	
	private static Color red = new Color(200,0,0);
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	private static String[] POSITIONS = { "-", "PG", "SG", "SF", "PF", "C"};
	private Player[] players;
	private JButton[] jb;
	private JPanel[] playerpanels;
	private JLabel[] teamlabel;
	private JPanel ppanel;
	private GameDraft panel;
	private JLabel[] pickedat;
	private Team[] teams;
	private boolean[] taken;
	private int apick;
	private PlayerChooser pc;
	private List<Player> sortedplayers;
	private int nr;
	public GameDraft(GameMain main) {
		super();
		_main=main;
		panel=this;
		calculatestuff();
		int n=main.opponents.length*2+6;
		generatePlayers(n);
		
		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);


		
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		JPanel headpanel = new JPanel();
		c.gridx = 0; c.gridy = 0; this.add(headpanel, c);
		headpanel.setLayout(new GridBagLayout());
		GridBagConstraints hc= new GridBagConstraints();
		ppanel = new JPanel();
		ppanel.setLayout(new GridBagLayout());
		ppanel.setMinimumSize(new Dimension(500, 450));
		ppanel.setPreferredSize(new Dimension(500, 450));

		GridBagConstraints ppc= new GridBagConstraints();
		playerpanels = new JPanel[(n/20)+1];
		playerpanels[0] = new JPanel();
		for (int i=0;i<playerpanels.length;i++){
			playerpanels[i] = new JPanel();
			JButton b= new JButton(i+"");
			drawPlayerList(playerpanels[i], i*20, i*20+20);
			hc.gridy = 0; hc.gridx = i; headpanel.add(b, hc);
			b.setName(i+"");
			b.addActionListener(viewListener);
			ppc.gridy = 0; ppc.gridx = 0; ppanel.add(playerpanels[i], ppc);
			
			
		}
		
		c.gridx = 0; c.gridy = 1; this.add(ppanel, c);
		
		JPanel teampanel = new JPanel();
		c.gridx = 1; c.gridy = 1; this.add(teampanel, c);
		teampanel.setLayout(new GridBagLayout());
		GridBagConstraints tc= new GridBagConstraints();
		
		
		JLabel desc = new JLabel("Draft Order");
		desc.setFont(new Font(null, Font.BOLD, 16));
		
		tc.gridx = 0; tc.gridy = 0; teampanel.add(desc, tc);
		teams = new Team[2*(_main.opponents.length+1)];
		teamlabel = new JLabel[(_main.opponents.length+1)];
		for (int i = 1;i<=2*(_main.opponents.length+1);i++) {
			for (int j=0;j<_main.opponents.length+1;j++ ) {
				Team t;
				if (j == 0) t = _main.team;
				else t = _main.opponents[j-1];
				if (t.draftpicks[0] == i) {
					teams[i-1] = t;
					teamlabel[i-1] = new JLabel(i + ". "+t.name);
					tc.gridx = 0; tc.gridy = i; teampanel.add(teamlabel[i-1], tc);
					teamlabel[i-1].setFont(smaller);
					if (t==_main.team) teamlabel[i-1].setForeground(blue);
				}
				if (t.draftpicks[1] == i) {
					teams[i-1] = t;
				}
			}
			

		}
		simulateDraft(0);
		
	}
	private void calculatestuff() {
		
		_main.season_phase=Game.SEASON_DURING_DRAFT;
		_main.repaint();
		
		
	}
	
	private void drawPlayerList(JPanel playerpanel, int begin, int end) {
		playerpanel.setLayout(new GridBagLayout());
		GridBagConstraints pc= new GridBagConstraints();

		
		JLabel desc = new JLabel("Name");
		pc.gridy = 0; pc.gridx = 0; playerpanel.add(desc, pc);
		desc=  new JLabel(" Age     ");
		pc.gridy = 0; pc.gridx = 1; playerpanel.add(desc, pc);
		
		desc=  new JLabel("Position");
		pc.gridy = 0; pc.gridx = 2; playerpanel.add(desc, pc);
		
		
		desc=  new JLabel("SC ");
		pc.gridy = 0; pc.gridx = 3; playerpanel.add(desc, pc);
		
		
		desc=  new JLabel("PS ");
		pc.gridy = 0; pc.gridx = 4; playerpanel.add(desc, pc);
		
		
		desc=  new JLabel("RB ");
		pc.gridy = 0; pc.gridx = 5; playerpanel.add(desc, pc);
		
		
		desc=  new JLabel("DF   ");
		pc.gridy = 0; pc.gridx = 6; playerpanel.add(desc, pc);
		desc=  new JLabel("                    ");
		pc.gridy = 0; pc.gridx = 7; playerpanel.add(desc, pc);
		
		for (int i=begin;i<end;i++){
			if (i== players.length) break;
			Player p = players[i];
			desc = new JLabel(p.firstname+ " "+p.lastname);
			desc.setFont(smaller);
			pc.gridy = i+1-begin; pc.gridx = 0; playerpanel.add(desc, pc);


			desc=  new JLabel(p.age+"  ");
			desc.setFont(smaller);
			pc.gridy = i+1-begin; pc.gridx = 1; playerpanel.add(desc, pc);
			
			desc=  new JLabel(POSITIONS[p.position]+"  ");
			desc.setFont(smaller);
			pc.gridy = i+1-begin; pc.gridx = 2; playerpanel.add(desc, pc);
			
			
			desc=  new JLabel(p.skill_scoring+"  ");
			desc.setFont(smaller);
			pc.gridy = i+1-begin; pc.gridx = 3; playerpanel.add(desc, pc);
			if (p.skill_scoring > 6) desc.setForeground(green);
			else if (p.skill_scoring < 3) desc.setForeground(red);
			else if (p.skill_scoring < 5) desc.setForeground(orange);
			else desc.setForeground(blue);
			
			desc=  new JLabel(p.skill_passing+"  ");
			desc.setFont(smaller);
			pc.gridy = i+1-begin; pc.gridx = 4; playerpanel.add(desc, pc);
			if (p.skill_passing > 6) desc.setForeground(green);
			else if (p.skill_passing < 3) desc.setForeground(red);
			else if (p.skill_passing < 5) desc.setForeground(orange);
			else desc.setForeground(blue);
			
			desc=  new JLabel(p.skill_rebounds+"  ");
			desc.setFont(smaller);
			pc.gridy = i+1-begin; pc.gridx = 5; playerpanel.add(desc, pc);
			if (p.skill_rebounds > 6) desc.setForeground(green);
			else if (p.skill_rebounds < 3) desc.setForeground(red);
			else if (p.skill_rebounds < 5) desc.setForeground(orange);
			else desc.setForeground(blue);
			
			desc=  new JLabel(p.skill_defense+"  ");
			desc.setFont(smaller);
			pc.gridy = i+1-begin; pc.gridx = 6; playerpanel.add(desc, pc);
			if (p.skill_defense > 6) desc.setForeground(green);
			else if (p.skill_defense < 3) desc.setForeground(red);
			else if (p.skill_defense < 5) desc.setForeground(orange);
			else desc.setForeground(blue);

			jb[i] = new JButton("");
			jb[i].setSize(2, 2);
			jb[i].setToolTipText("Draft that player");
			pc.gridy = i+1-begin; pc.gridx = 7; playerpanel.add(jb[i], pc);
			jb[i].setName(i+"");
			jb[i].addActionListener(pickListener);
			
			pickedat[i]=  new JLabel("  -   ");
			pickedat[i].setFont(smaller);
			pc.gridy = i+1-begin; pc.gridx = 8; playerpanel.add(pickedat[i], pc);

		}
		
		
	}
	
	private void simulateDraft(int id) {
		apick =id;
		Team t;
		if (apick<teams.length){
			t = teams[apick];
			while (t != _main.team && apick<teams.length) {
				int p = choosePlayer();
				draftPlayer(apick, p);
				apick++;
				
				if (apick<teams.length)t = teams[apick];
				else {
					_main.season_phase = Game.SEASON_OFFSEASON;
					League.newSeason(_main);
					_main.mainpanel.removeAll();
					_main.mainpanel.add(new GameContracts(_main));
					_main.repaint();
				}
			}
		}
		else {
			_main.season_phase = Game.SEASON_OFFSEASON;
			League.newSeason(_main);
			_main.mainpanel.removeAll();
			_main.mainpanel.add(new GameContracts(_main));
			_main.repaint();
		}

		
	}
	private int choosePlayer() {
		int i=0;
		boolean choiceMade =false;
		Player player;
		while (!choiceMade && i<players.length) {
			int j=0;
			player= sortedplayers.get(i);
			
			while (true) {
				if (players[j] == player) {
					if (!taken[j] )	return j;
					else break;
				}
				if (j == players.length-1) break;
				j++;
			}
			i++;
		}
		return 0;
	}
	private void draftPlayer(int pick, int id) {
		if (!taken[id]){
			jb[id].setEnabled(false);
			pickedat[id].setText("  "+(pick+1)+".  ");
			taken[id] = true;
			if (teams[pick]!= _main.team)teams[pick].findRosterSpot(players[id],_main.league);
			teamlabel[Func.mod(pick,teamlabel.length)].setText(teamlabel[Func.mod(pick,teamlabel.length)].getText()+" ; "+ players[id].firstname+ " " +players[id].lastname);
		}
	}
	
	private void generatePlayers(int n) {
		players= new Player[n];
		Player[] tmpplayers = new Player[n];
		jb= new JButton[n];
		pickedat = new JLabel[n];
		taken = new boolean[n];
		for (int i=0;i<n;i++) {
			players[i] = Player.randomPlayer();
			tmpplayers[i] = players[i];
			taken[i] = false;
		
		}
		sortedplayers = Arrays.asList(tmpplayers);
		
		Collections.sort(sortedplayers);
			
	}
	private ActionListener pickListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			nr = Integer.parseInt(((JButton)e.getSource()).getName());
			Player newplayer = players[nr];
			if (_main.team.freeSpots()>0) {
				_main.team.findRosterSpot(newplayer, _main.league);
				draftPlayer(apick,nr);
				apick++;
				panel.simulateDraft(apick);
			}
			else {
					
				
				pc = new PlayerChooser(_main.team, newplayer,al);
				
				pc.setAlwaysOnTop(true);
				
				
			}
			
			
		}
	};
	
	private ActionListener viewListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int i = Integer.parseInt(((JButton)e.getSource()).getName());
			ppanel.removeAll();

			ppanel.add(playerpanels[i]);
		

			ppanel.repaint();
			
		}
	};

	ActionListener al = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int choice = pc.jc.getSelectedIndex();
			if (choice!=0) pc.t.players[choice-1] = pc.p;
			pc.window.dispose();
			draftPlayer(apick,nr);
			apick++;
			panel.simulateDraft(apick);
		}
	};
}
