package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import main.*;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class GameFreeAgents extends JPanel{
	private GameFreeAgents window;

	private GameMain _main;
	private Player[] fa;
	private int[] salary;
	private JButton[] button;
	private JComboBox[] combobox;
	private JComboBox pagebox;
	private JComboBox order;
	private int orderby;
	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color red = new Color(255,0,0);
	private static Color blue = new Color(0,0,200);
	private int limit =15;
	private int page;
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	private static Font bigger = new Font("SansSerif", Font.PLAIN, 18);
	private static String[] orderarray = {"name", "value", "pos", "age"};
	private String[] positions = { "PG", "SG", "SF", "PF", "C"};

	
	public GameFreeAgents(GameMain main, int page, int orderby) {
		super();
		this.page=page;
		_main=main;
		this.orderby=orderby;
		fa = _main.league.free_agents;
		QuickSort.quicksort(fa, orderby);
		int len=Math.min(fa.length, limit);
		button = new JButton[len];
		salary = new int[len];
		combobox = new JComboBox [len];
		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);
		boolean s =false;
		if (_main.team.freeSpots()>0) s=true;
		
		showDialog(s);
	}
	private void showDialog(boolean signing){
		window=this;

		
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		
		
		
		c.fill = GridBagConstraints.BOTH;

		JLabel desc = new JLabel("Free Agents - page"+(page+1));
		desc.setFont(bigger);
		desc.setForeground(blue);
		c.gridx = 1; c.gridy = 0; this.add(desc, c);
		String[] options = new String[(fa.length / limit )+1];
		for (int ii=0;ii<(fa.length / limit )+1;ii++) {
			options[ii] = "page "+(ii+1);
		}
		pagebox = new JComboBox(options);
		pagebox.setSelectedIndex(page);
		pagebox.addActionListener(pageListener);
		
		if (options.length==1) pagebox.setEnabled(false);
		c.gridx = 11; c.gridy = 0; this.add(pagebox, c);
		
		order = new JComboBox(orderarray);
		int selected = 0;
		if  (orderby == QuickSort.SALARY) selected =1;
		if (orderby == QuickSort.POS) selected =2;
		if (orderby == QuickSort.YRS) selected =3;
		order.setSelectedIndex(selected);
		order.addActionListener(orderListener);
		c.gridx = 12; c.gridy = 0; this.add(order, c);
		desc = new JLabel("Position  ");
		c.gridx = 0; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("Name");
		c.gridx = 1; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("  Age  ");
		c.gridx = 2; c.gridy = 1; this.add(desc, c);
		desc= new JLabel(" Season ");
		c.gridx = 3; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("  |   ");
		c.gridx = 4; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("  SCR   ");
		c.gridx = 5; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("  PAS   ");
		c.gridx = 6; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("  REB   ");
		c.gridx = 7; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("   DEF   ");
		c.gridx = 8; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("  |   ");
		c.gridx = 9; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("   $   ");
		c.gridx = 10; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("   length of contract  ");
		c.gridx = 11; c.gridy = 1; this.add(desc, c);
		desc= new JLabel("   sign  ");
		c.gridx = 12; c.gridy = 1; this.add(desc, c);
		

		
		for (int i=0;i<limit;i++){
			if (limit*page + i >= fa.length ) break;
			salary[i] = fa[limit*page + i].calculateSalary();
			desc = new JLabel(positions[fa[limit*page + i].position-1]);
			c.gridx = 0; c.gridy = i+2; this.add(desc, c);
			desc = new JLabel(fa[limit*page + i].firstname+" "+fa[limit*page + i].lastname);
			c.gridx = 1; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(fa[limit*page + i].age+"");
			c.gridx = 2; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(fa[limit*page + i].seasons+"");
			c.gridx = 3; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel("  |   ");
			c.gridx = 4; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(fa[limit*page + i].skill_scoring+"");
			c.gridx = 5; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(fa[limit*page + i].skill_passing+"");
			c.gridx = 6; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(fa[limit*page + i].skill_rebounds+"");
			c.gridx = 7; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(fa[limit*page + i].skill_defense+"");
			c.gridx = 8; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel("  |   ");
			c.gridx = 9; c.gridy = i+2; this.add(desc, c);
			desc= new JLabel(salary[i]+"");
			c.gridx = 10; c.gridy = i+2; this.add(desc, c);
			options = new String[5];
			for (int j=0;j<5;j++) {
				options[j] = (j+1)+" years: "+(j+1)*salary[i]+" $";
			}
			combobox[i] = new JComboBox(options);
			combobox[i].addActionListener(comboListener);
			combobox[i].setName(i+"");
			if (!signing) combobox[i].setEnabled(false);
			c.gridx = 11; c.gridy = i+2; this.add(combobox[i], c);
			button[i] = new JButton("Sign");
			if (!signing ||salary[i] > _main.team.credits) button[i].setEnabled(false);
			button[i].setName(i+"");
			button[i].addActionListener(signListener);
			c.gridx = 12; c.gridy = i+2; this.add(button[i], c);
		}
		
		this.setVisible(true);
	}
	private ActionListener comboListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int id = Integer.parseInt(((JComboBox)e.getSource()).getName());
			int i = ((JComboBox)e.getSource()).getSelectedIndex()+1;
			
			if (i*salary[id] > _main.team.credits) {
				button[id].setEnabled(false);
			}
			else button[id].setEnabled(true);
			 
		}
	};
	private ActionListener pageListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int id = ((JComboBox)e.getSource()).getSelectedIndex();
			_main.mainpanel.removeAll();
			_main.mainpanel.add(new GameFreeAgents(_main, id, orderby));
			_main.repaint();
			 
		}
	};
	private ActionListener signListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int id = Integer.parseInt(((JButton)e.getSource()).getName());
			_main.team.credits = _main.team.credits -((combobox[id].getSelectedIndex()+1)*salary[id]);
			_main.team.findRosterSpot(fa[id+limit*page], _main.league);
			_main.league.removeFA(id+limit*page);
			_main.mainpanel.removeAll();
			_main.mainpanel.add(new GameFreeAgents(_main, page, orderby));
			_main.repaint();
		}
	};
	private ActionListener orderListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int id = ((JComboBox)e.getSource()).getSelectedIndex();
			if (id == 0) orderby = QuickSort.NAME;
			if (id == 1) orderby = QuickSort.SALARY;
			if (id == 2) orderby = QuickSort.POS;
			if (id ==3) orderby = QuickSort.YRS;
			_main.mainpanel.removeAll();
			_main.mainpanel.add(new GameFreeAgents(_main, page, orderby));
			_main.repaint();
			 
		}
	};

}
