package dialogs;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JTextField;

import main.Game;
public class GameInfo extends JPanel{
	private GameMain _main;
	private JLabel recordLabel;
	private JLabel nextopLabel;
	private JLabel dateLabel;
	private JLabel seasonLabel;
	private JLabel creditsLabel;
	private JLabel scoreLabel;
	private static Color black = new Color(0,0,0);
	private static Color green = new Color(0,200,0);
	private static Color blue = new Color(0,0,200);
	private static Color red = new Color(255,0,0);
	private Font banner = new Font("SansSerif", Font.BOLD, 20);
	private Font smaller = new Font("SansSerif", Font.BOLD, 10);
	
	public GameInfo(GameMain main) {
		super();
		_main=main;
		
		recordLabel= new JLabel("0 : 0");
		nextopLabel = new JLabel("Next Opponent: ");
		dateLabel = new JLabel("   "+(_main.date.getMonth()+1)+"/"+_main.date.getDate()+"/"+_main.date.getYear());
		seasonLabel = new JLabel("Season 2007/08");
		creditsLabel= new JLabel("credits");
		scoreLabel= new JLabel("points");
		scoreLabel.setFont(smaller);
		this.setBackground(new Color(200,200,255));
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();		
		c.insets=new Insets(5,5,5,5);
		JLabel label = new JLabel(_main.team.name);
		label.setFont(banner);
		c.gridx=1; c.gridy=0; add(label, c);


		c.gridx=2; c.gridy=0; add(recordLabel, c);
		c.gridx=3; c.gridy=0; add(dateLabel, c);
		c.gridx=0; c.gridy=0; add(seasonLabel, c);
		c.gridx=4; c.gridy=0; add(nextopLabel, c);
		c.gridx=5; c.gridy=0; add(creditsLabel, c);
		c.gridx=5; c.gridy=1; add(scoreLabel, c);
		
		updateInfo();
	}
	
	public void updateInfo() {
		if (recordLabel!=null) {
			recordLabel.setText("("+_main.team.games_won+" : "+_main.team.games_lost+")");
		}
		if (nextopLabel != null && _main.nextopponent!=null) {
			nextopLabel.setText("    Next opponent: "+_main.nextopponent.name);
		}
		if (dateLabel != null) {
			int month = _main.date.getMonth()+1;
			
			dateLabel.setText("   "+month+"/"+_main.date.getDate()+"/"+_main.date.getYear());
		}
		if (seasonLabel != null) {
			String text = "Season "+(2006+_main.season)+"/";
			if (_main.season<3) text+="0";
			text+=(7+_main.season);
			seasonLabel.setForeground(black);
			
			if (_main.season_phase == Game.SEASON_FINALS) {
				text +=" FINALS";
				seasonLabel.setForeground(green);
			}
			else if (_main.season_phase == Game.SEASON_PLAYOFFS){
				text +=" Playoffs";
				seasonLabel.setForeground(blue);
			}
			
			seasonLabel.setText(text);
		}
		if (scoreLabel!=null) {
			scoreLabel.setText(_main.team.score +" points");
		}
		if (creditsLabel!=null) {
			creditsLabel.setText(_main.team.credits +" $");
		}
		
		
		repaint();
	}
	
}
