package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import main.*;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class GameLeaders extends JPanel{
	private GameLeaders window;

	private GameMain _main;
	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color blue= new Color(0,0,200);
	
	private static Color red = new Color(255,0,0);
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	private static Font bigger = new Font("SansSerif", Font.PLAIN, 20);

	public static int ETERNAL=0;
    public static int NAME=6;
    public static int PPG=1;
    public static int APG=2;
    public static int RPG=3;
    public static int YRS=4;
    public static int YRS2=10;
    
    public static int SALARY=5;
	
	public GameLeaders(GameMain main, int mode) {
		super();
		_main=main;

		int limit=30;
		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);

		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
	
		String[] statnames = new String[6];
		statnames[0] = "Team-Points";
		statnames[1] = "Player-PPG";
		statnames[2] = "Player-APG";
		statnames[3] = "Player-RPG";
		statnames[4] = "oldest players";

		statnames[5] = "Highest salary";
		
		
		c.fill = GridBagConstraints.BOTH;
		JComboBox choosestat= new JComboBox(statnames);
		choosestat.addActionListener(statsListener);
		c.gridx = 0; c.gridy = 0; this.add(choosestat, c);

		
		if (mode==ETERNAL){
			JLabel desc = new JLabel("Total score");
			desc.setFont(bigger);
			desc.setForeground(green);
			c.gridx=1;c.gridy=1;add(desc, c);
		
			Team[] teams=new Team[_main.opponents.length+1];
			teams[0]=_main.team;
			for (int i=0;i<_main.opponents.length;i++){
				teams[i+1]=_main.opponents[i];
			}
			QuickSort.quicksort(teams);
			for (int i=0;i<Math.min(teams.length,limit);i++){
				desc= new JLabel(teams[i].name+ " : "+teams[i].score);
				c.gridx=1;c.gridy=i+2;add(desc, c);
				if (teams[i]==_main.team) desc.setForeground(blue);	
			}
		}
		else if (mode==PPG){
			JLabel desc = new JLabel("Top scorers");
			desc.setFont(bigger);
			desc.setForeground(green);
			c.gridx=1;c.gridy=1;add(desc, c);
		
			Object[] players=Game.allPlayers(_main);
			
	
			QuickSort.quicksort(players, QuickSort.PPG);
			for (int i=0;i<Math.min(players.length,limit);i++){
				Player p=((Player)players[i]);
				desc= new JLabel(p.firstname+ " "+p.lastname+": ");
				c.gridx=1;c.gridy=i+2;add(desc, c);
				desc= new JLabel(Func.div(p.stats_points,p.stats_games)+" PPG");
				c.gridx=2;c.gridy=i+2;add(desc, c);
				
				if (p.memberOf(_main.team)) desc.setForeground(blue);	
			}
		}	
		else if (mode==APG){
			JLabel desc = new JLabel("Assists Leaders");
			desc.setFont(bigger);
			desc.setForeground(green);
			c.gridx=1;c.gridy=1;add(desc, c);
		
			Object[] players=Game.allPlayers(_main);
			
	
			QuickSort.quicksort(players, QuickSort.APG);
			for (int i=0;i<Math.min(players.length,limit);i++){
				Player p=((Player)players[i]);
				desc= new JLabel(p.firstname+ " "+p.lastname+": ");
				c.gridx=1;c.gridy=i+2;add(desc, c);
				desc= new JLabel(Func.div(p.stats_assists,p.stats_games)+" APG");
				c.gridx=2;c.gridy=i+2;add(desc, c);
				
				if (p.memberOf(_main.team)) desc.setForeground(blue);	
			}
		}
		else if (mode==RPG){
			JLabel desc = new JLabel("Rebound Leaders");
			desc.setFont(bigger);
			desc.setForeground(green);
			c.gridx=1;c.gridy=1;add(desc, c);
		
			Object[] players=Game.allPlayers(_main);
			
	
			QuickSort.quicksort(players, QuickSort.RPG);
			for (int i=0;i<Math.min(players.length,limit);i++){
				Player p=((Player)players[i]);
				desc= new JLabel(p.firstname+ " "+p.lastname+": ");
				c.gridx=1;c.gridy=i+2;add(desc, c);
				desc= new JLabel(Func.div(p.stats_rebounds,p.stats_games)+" RPG");
				c.gridx=2;c.gridy=i+2;add(desc, c);
				
				if (p.memberOf(_main.team)) desc.setForeground(blue);	
			}
		}
		else if (mode==YRS){
			JLabel desc = new JLabel("Oldest players");
			desc.setFont(bigger);
			desc.setForeground(green);
			c.gridx=1;c.gridy=1;add(desc, c);
		
			Object[] players=Game.allPlayers(_main);
			
	
			QuickSort.quicksort(players, QuickSort.YRS);
			for (int i=0;i<Math.min(players.length,limit);i++){
				Player p=((Player)players[i]);
				desc= new JLabel(p.firstname+ " "+p.lastname+": ");
				c.gridx=1;c.gridy=i+2;add(desc, c);
				desc= new JLabel(p.age+" years");
				c.gridx=2;c.gridy=i+2;add(desc, c);
				
				if (p.memberOf(_main.team)) desc.setForeground(blue);	
			}
		}
		else if (mode==YRS2){
			JLabel desc = new JLabel("Oldest players");
			desc.setFont(bigger);
			desc.setForeground(green);
			c.gridx=1;c.gridy=1;add(desc, c);
		
			Object[] players=Game.allPlayers(_main);
			
	
			QuickSort.quicksort(players, QuickSort.YRS2);
			for (int i=0;i<Math.min(players.length,limit);i++){
				Player p=((Player)players[i]);
				desc= new JLabel(p.firstname+ " "+p.lastname+": ");
				c.gridx=1;c.gridy=i+2;add(desc, c);
				desc= new JLabel(p.age+" years");
				c.gridx=2;c.gridy=i+2;add(desc, c);
				
				if (p.memberOf(_main.team)) desc.setForeground(blue);	
			}
		}
		else if (mode==SALARY){
			JLabel desc = new JLabel("Best payed");
			desc.setFont(bigger);
			desc.setForeground(green);
			c.gridx=1;c.gridy=1;add(desc, c);
		
			Object[] players=Game.allPlayers(_main);
			
	
			QuickSort.quicksort(players, QuickSort.SALARY);
			for (int i=0;i<Math.min(players.length,limit);i++){
				Player p=((Player)players[i]);
				desc= new JLabel(p.firstname+ " "+p.lastname+": ");
				c.gridx=1;c.gridy=i+2;add(desc, c);
				desc= new JLabel(p.annual_salary+" $");
				c.gridx=2;c.gridy=i+2;add(desc, c);
				
				if (p.memberOf(_main.team)) desc.setForeground(blue);	
			}
		}
	}
	private ActionListener statsListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int i = ((JComboBox)e.getSource()).getSelectedIndex();
			_main.mainpanel.removeAll();
			_main.mainpanel.add(new GameLeaders(_main, i));
			_main.repaint();
		}
	};
		
	
}
