package dialogs;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.io.File;
import java.util.Date;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import main.*;

public class GameMain extends JFrame{
	private static int days = 1000*60*60*24;
	public JPanel mainpanel;
	public GameMenu menupanel;
	public GameInfo infopanel;
	public HelpButton help;
	public JMenuBar menubar;
	public Team team;
	public Team[] opponents;
	public Team nextopponent;
	public League league;
	public int season_phase =1;
	public Date date = new Date(2007,10,1);
	public int day = 0;
	public int matchonday=0;
	public int season=1;
	public int po_round;
	public Dimension mainsize =new Dimension(796,546);
	public GameMain(Game game) {
		super("Panschk's Basketball Manager 08");
		loadGame(game);
		go();
	}
	
	public void go() {
		
		this.setSize(950, 660);
		
		infopanel = new GameInfo(this);
		help = new HelpButton(this);

		menupanel = new GameMenu(this);
		mainpanel=new JPanel();
		mainpanel.setPreferredSize(new Dimension(800,550));
		mainpanel.setMinimumSize(new Dimension(800,550));
		mainpanel.setMaximumSize(new Dimension(800,550));
		
		mainpanel.setBackground(new Color(200,200,255));
		mainpanel.add(new GameRoster(this));
		
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();		
		c.insets=new Insets(5,5,5,5);
		c.gridx = 0; c.gridy=0;add(infopanel);
		c.gridx = 0; c.gridy = 1; add(mainpanel, c);
		c.gridx = 1; c.gridy = 0; add(help, c);

		c.anchor=GridBagConstraints.EAST;c.gridx = 1; c.gridy = 1; add(menupanel, c);

		this.setVisible(true);
	}
	public void repaint() {
		mainpanel.validate();
		mainpanel.repaint();
		
		infopanel.updateInfo();
		menupanel.update();
		
	}
	public void nextGame() {
		nextopponent = null;
		if (season_phase == Game.SEASON_PLAYOFFS || season_phase == Game.SEASON_FINALS) {
			day = day+2 + Func.mod(day, 2);
			if (team.games_won == league.best_of_x_in_playoffs || team.games_lost == league.best_of_x_in_playoffs){
				League.nextRound(this);
			}
			int i=1;
			while (nextopponent == null && i<opponents.length+1) {
				int round = league.games[0][0][i].day / 100 ;
				if (round == this.po_round) {
					nextopponent = opponents[i-1];	
				}
				i++;
			}
			if (nextopponent == null) {
				nextopponent = new Team();
				nextopponent.name="Your team has been eliminated";
				while (season_phase != Game.SEASON_AFTER_PO ) {
					League.nextRound(this);
				}
				season_phase = Game.SEASON_AFTER_PO;
			}
			
			
			for (int j=1;j<opponents.length;j++) {
				for (int k=j+1;k<opponents.length;k++) {
					int round = league.games[0][j][k].day / 100 ;
					if (round == this.po_round && (
						(opponents[j-1].games_won < league.best_of_x_in_playoffs)&&
						opponents[k-1].games_won < league.best_of_x_in_playoffs)) {
						BoxScore boxscore = new BoxScore(opponents[j-1],opponents[k-1], true);
						boxscore.updateStats();
						
					}
				}
			}
		}
		
		if (season_phase == Game.SEASON_REGULAR) {
			while (nextopponent == null) {
		
			List<GameDate> gameslist = league.getAllGamesonDayX(day);
				if (gameslist.size()> matchonday){
					for (int i =matchonday;i<gameslist.size();i++) {
						
						if (gameslist.get(i).team1index==0) {
							nextopponent = opponents[gameslist.get(i).team2index-1];
							matchonday++;
							break;
						}
						else {
							matchonday++;
							BoxScore boxscore = new BoxScore(opponents[gameslist.get(i).team1index-1],opponents[gameslist.get(i).team2index-1], true);
							boxscore.updateStats();
						}
					}
				}
				else {
					day++;
					date.setTime(date.getTime()+days);
					matchonday=0;
					if (day>League.DAYS_RS) {
						nextopponent = new Team();
						nextopponent.name="Season is over :)";
						season_phase = Game.SEASON_AFTER_RS;
					}
						
					
					try {
						repaint();
					} catch (Exception ex) {}
				}
			}
		}
		
	}

	public void loadGame(Game game) {
		team=game.team;
		opponents=game.opponents;
		day=game.day;
		if (matchonday>0) matchonday=game.matchonday-1;
		else if (day>0 && season_phase == Game.SEASON_REGULAR) day--;
		league=game.league;
		po_round = game.po_round;
		season_phase=game.season_phase;
		Date tmpdate = new Date(2006+season, 11, 1);
		long timestamp = tmpdate.getTime();
		date = new Date(timestamp+day*days);
		season=game.season;
		nextGame();
		
	}
	
	
	
}
