package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import main.*;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class GamePlayerStats extends JPanel{
	private GamePlayerStats window;
	private JTextField filename;
	private JTextField teamname;
	private Team team;
	private Team opponent;
	private JLabel[][] players;
	private JLabel[][] oplayers;
	private GameMain _main;
	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color red = new Color(255,0,0);
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	
	private String[] positions = { "PG", "SG", "SF", "PF", "C", "pg", "sg", "sf", "pf", "c", "11", "12", "13", "14", "15" };

	
	public GamePlayerStats(GameMain main, Team showteam) {
		super();
		_main=main;
		opponent=_main.opponents[0];
		this.team = showteam;
		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);

		showDialog(team);
	}
	private void showDialog(Team team){
		window=this;

		
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		
		String[] teamnames = new String[_main.opponents.length+2];
		teamnames[0] = "select team";
		teamnames[1] = _main.team.name;
		
		for (int i =0;i<_main.opponents.length;i++) {
			teamnames[i+2] = _main.opponents[i].name;
			
		}
		
		c.fill = GridBagConstraints.BOTH;
		JComboBox chooseteam = new JComboBox(teamnames);
		chooseteam.addActionListener(teamListener);
		c.gridx = 0; c.gridy = 0; this.add(chooseteam, c);

		int i = 2;
		JLabel desc = new JLabel(team.name+"    ");
		c.gridx = 0; c.gridy = i; this.add(desc, c);

		i++;
		
		desc = new JLabel("Position  ");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		desc= new JLabel("Name");
		c.gridx = 1; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = 2; c.gridy = i; this.add(desc, c);
		desc= new JLabel("GAMES ");
		c.gridx = 3; c.gridy = i; this.add(desc, c);
		desc= new JLabel("PTS   ");
		c.gridx = 4; c.gridy = i; this.add(desc, c);
		desc= new JLabel("REB   ");
		c.gridx = 5; c.gridy = i; this.add(desc, c);
		desc= new JLabel("AST   ");
		c.gridx = 6; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = 7; c.gridy = i; this.add(desc, c);
		desc= new JLabel("PPG   ");
		c.gridx = 8; c.gridy = i; this.add(desc, c);
		desc= new JLabel("RPG   ");
		c.gridx = 9; c.gridy = i; this.add(desc, c);
		desc= new JLabel("APG   ");
		c.gridx = 10; c.gridy = i; this.add(desc, c);
		
		
		i++;
		
		
		for (int j=0;j<15;j++){
			
			desc = new JLabel(positions[j]);
			c.gridx = 0; c.gridy = i; this.add(desc, c);
			desc=  new JLabel(team.players[j].lastname.toUpperCase()+" "+team.players[j].firstname);
			c.gridx = 1; c.gridy = i; this.add(desc, c);
			desc= new JLabel("  |  ");
			c.gridx = 2; c.gridy = i; this.add(desc, c);
			desc= new JLabel(team.players[j].stats_games+"");
			
			c.gridx = 3; c.gridy = i; this.add(desc, c);
			desc= new JLabel(team.players[j].stats_points+"");
			c.gridx = 4; c.gridy = i; this.add(desc, c);
			desc= new JLabel(team.players[j].stats_rebounds+"");
			c.gridx = 5; c.gridy = i; this.add(desc, c);
			desc= new JLabel(team.players[j].stats_assists+"");
			c.gridx = 6; c.gridy = i; this.add(desc, c);
			desc= new JLabel("  |  ");
			c.gridx = 7; c.gridy = i; this.add(desc, c);
			desc= new JLabel(Func.div(team.players[j].stats_points,team.players[j].stats_games)+"  ");
			c.gridx = 8; c.gridy = i; this.add(desc, c);
			desc= new JLabel(Func.div(team.players[j].stats_rebounds,team.players[j].stats_games)+"  ");
			c.gridx = 9; c.gridy = i; this.add(desc, c);
			desc= new JLabel(Func.div(team.players[j].stats_assists,team.players[j].stats_games)+"  ");
			c.gridx = 10; c.gridy = i; this.add(desc, c);
			
			i++;

		}
		
		this.setVisible(true);
	}
	

	private ActionListener teamListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int i = ((JComboBox)e.getSource()).getSelectedIndex()-1;
			if (i == 0) {
				window.removeAll();
				showDialog(_main.team);
				repaint();
				_main.repaint();
			}
			if (i > 0) {
				window.removeAll();
				showDialog(_main.opponents[i-1]);
				repaint();
				_main.repaint();
				
			}
		}
	};

}
