package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import main.*;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class GameStandings extends JPanel{

	private GameMain _main;

	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color blue = new Color(0,0,200);
	private static Color red = new Color(255,0,0);
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	
	
	public GameStandings(GameMain main) {
		super();
		_main=main;

		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);


	
	
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		
		c.fill = GridBagConstraints.BOTH;	
		if (_main.season_phase == Game.SEASON_AFTER_RS || _main.season_phase == Game.SEASON_REGULAR){
			
			int n= main.league.conference_numbers;
			int m = main.league.teams_conference.length;
			List[] division_standings = new List[n];
			for (int i=0; i<n;i++) {
				int counter=0;
				int k=0;
				for (int j=0; j<m;j++) {
					if (main.league.teams_conference[j]==i) counter++;
				}
				Object[] data = new Team[counter];
				
				for (int j=0;j<counter;j++){
					
					while (true) {
						if (main.league.teams_conference[k]==i) {
							if (k ==0) data[j] = _main.team; 
							else data[j] = _main.opponents[k-1];
							k++;
							break;
						}
						k++;
					}
					
				}
				List list = Arrays.asList(data);
	
				Collections.sort(list);
				division_standings[i] = list;
			}
			
	
			JPanel jp = new JPanel();
			
			c.gridx = 0; c.gridy = 0; this.add(jp, c);
			GridBagLayout gridbag2=new GridBagLayout();
			jp.setLayout(gridbag2);
			GridBagConstraints c2 = new GridBagConstraints();
			
			
			JLabel desc = new JLabel("Standings");
			desc.setFont(new Font(null, Font.PLAIN, 18));
			c2.gridx = 0; c2.gridy = 0; jp.add(desc, c2);
			for (int i=0;i<division_standings.length;i++) {
	
				desc = new JLabel(_main.league.conference_names[i]);
				desc.setFont(new Font(null, Font.PLAIN, 18));
				c2.gridx = 3*i; c2.gridy = 1; jp.add(desc, c2);
				List list = division_standings[i];
				for (int j=0;j<list.size();j++) {
					Team o = (Team)list.get(j);
					desc = new JLabel(o.name);
					if (j< _main.league.playoff_teams_par_conference) {
						desc.setForeground(green);
					}
					else {
						desc.setForeground(orange);
					}
					
					if (o==_main.team) {
						desc.setForeground(new Color(0, 80, 120));
					}
					c2.gridx = 3*i +0; c2.gridy = j+2; jp.add(desc, c2);
					desc = new JLabel("  "+o.games_won+"  ");
					if (j< _main.league.playoff_teams_par_conference) {
						desc.setForeground(green);
					}
					else {
						desc.setForeground(orange);
					}
					c2.gridx = 3*i+1; c2.gridy = j+2; jp.add(desc, c2);
					desc = new JLabel("  "+o.games_lost+"         ");
					if (j< _main.league.playoff_teams_par_conference) {
						desc.setForeground(green);
					}
					else {
						desc.setForeground(orange);
					}
					c2.gridx = 3*i+2; c2.gridy = j+2; jp.add(desc, c2);
					
				}
			}
		}
		
		else if (_main.season_phase == Game.SEASON_AFTER_PO||_main.season_phase == Game.SEASON_PLAYOFFS || _main.season_phase == Game.SEASON_FINALS) {
			int count =1;
			JLabel desc;
			
			// rounds that have already been played:
			for (int round = 1;round<_main.po_round;round++) {
				desc = new JLabel("Playoffs: Round "+round);
				desc.setForeground(blue);
				desc.setFont(new Font(null, Font.BOLD, 18));
				
				c.gridx = 0; c.gridy = count; this.add(desc, c);
				count++;
				for (int i =0;i<_main.opponents.length+1;i++) {
					for (int j=i+1;j<_main.opponents.length+1;j++) {
						if (_main.league.games[0][i][j].day/100 == round) {
							Team t1;
							Team t2;
							char w = 'v';
							if (i ==0 ) t1=_main.team;
							else t1= _main.opponents[i-1];
							t2 = _main.opponents[j-1];
							GameDate nxtr = _main.league.getAllGamesonDayX((round+1)*100 + (Func.mod(_main.league.games[0][i][j].day, 100)/2)).get(0);
							if (nxtr.team1index==i || nxtr.team2index == i) w='>';
							if (nxtr.team1index==j || nxtr.team2index == j) w='<';
							
							desc = new JLabel(t1.name+ "   "+w+"   "+t2.name);
							desc.setFont(new Font(null, Font.BOLD, 16));
							if (t1==_main.team) {
								desc.setForeground(new Color(0, 80, 120));
							}
							c.gridx = 0; c.gridy = count; this.add(desc, c);
						count++;
						}
					}
				}
			}
			
			
			if (_main.season_phase == Game.SEASON_AFTER_PO||_main.season_phase == Game.SEASON_FINALS) {
				desc = new JLabel("NBA FINALS");
				desc.setForeground(green);
			}
			else {
				desc = new JLabel("Playoffs: Round "+_main.po_round);
				desc.setForeground(blue);
			}
			desc.setFont(new Font(null, Font.BOLD, 20));
			
			c.gridx = 0; c.gridy = count; this.add(desc, c);
			count++;
			for (int i =0;i<_main.opponents.length+1;i++) {
				for (int j=i+1;j<_main.opponents.length+1;j++) {
					if (_main.league.games[0][i][j].day/100 == _main.po_round) {
						Team t1;
						Team t2;
						if (i ==0 ) t1=_main.team;
						else t1= _main.opponents[i-1];
						t2 = _main.opponents[j-1];
						desc = new JLabel(t1.name+ "   " + t1.games_won+ " : "+t2.games_won+ "   "+t2.name);
						if (t1==_main.team) {
							desc.setForeground(new Color(0, 80, 120));
						}
						desc.setFont(new Font(null, Font.BOLD, 16));
						c.gridx = 0; c.gridy = count; this.add(desc, c);
					count++;
					}
				}
			}
		}
	}


}
