package dialogs;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import main.*;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class GameTrade extends JPanel{
	private GameTrade window;
	private int showteam;
	private Team team;
	private Team opponent;
	private GameMain _main;
	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color blue = new Color(0,0,200);
	private JButton trade;
	private static Color red = new Color(255,0,0);
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	private static Font bigger = new Font("SansSerif", Font.PLAIN, 20);
	private JCheckBox[] checkbox1;
	private boolean[] cb1;
	private boolean[] cb2;
	private JCheckBox[] checkbox2;
	
	private String[] positions = { "-","PG", "SG", "SF", "PF", "C"};

	
	public GameTrade(GameMain main, int showteam) {
		super();
		this.showteam=showteam;
		_main=main;
		opponent=_main.opponents[showteam];
		team=_main.team;
		cb1=new boolean[15];
		cb2=new boolean[15];
		checkbox1=new JCheckBox[15];
		checkbox2=new JCheckBox[15];
		
		setMinimumSize(_main.mainsize);
		setPreferredSize(_main.mainsize);

		window=this;

		
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		
		
		GridBagConstraints c = new GridBagConstraints();
		JLabel desc=new JLabel("Trades:   "+opponent.name);
		desc.setForeground(blue);
		desc.setFont(bigger);
		c.gridx=0;c.gridy=0;add(desc,c);
		
		

		String[]options=new String[_main.opponents.length];
		for (int i=0;i<_main.opponents.length;i++){
			options[i]=_main.opponents[i].name;
		}
		
		JComboBox teamchooser=new JComboBox(options);
		teamchooser.addActionListener(teamListener);
		
		c.gridx=0;c.gridy=1;add(teamchooser,c);
		JPanel jp=new JPanel();
		c.gridx=0;c.gridy=2;add(jp,c);
		jp.setLayout(new GridBagLayout());
		c = new GridBagConstraints();
		desc= new JLabel(" Name ");
		c.gridx=0;c.gridy=3;jp.add(desc,c);
		desc= new JLabel(" POS ");
		c.gridx=1;c.gridy=3;jp.add(desc,c);
		desc= new JLabel(" Age ");
		c.gridx=2;c.gridy=3;jp.add(desc,c);
		
		desc= new JLabel(" |  ");
		c.gridx=3;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("sco. ");
		c.gridx=4;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("pas. ");
		c.gridx=5;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("reb. ");
		c.gridx=6;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("def. ");
		c.gridx=7;c.gridy=3;jp.add(desc,c);
		desc= new JLabel(" |  ");
		c.gridx=8;c.gridy=3;jp.add(desc,c);
		desc= new JLabel(" yrs_left.");
		c.gridx=9;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("  trade  ");
		c.gridx=10;c.gridy=3;jp.add(desc,c);
		
		for (int i=0;i<15;i++){
			cb1[i]=false;
			Player p=team.players[i];
			String fn="";
			if (p.firstname.length()>1)fn=p.firstname.substring(0, 1)+".";
			desc= new JLabel(fn+" "+p.lastname);
			c.gridx=0;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(positions[p.position]);
			c.gridx=1;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.age+"");
			c.gridx=2;c.gridy=i+4;jp.add(desc,c);
			
			desc= new JLabel(" |  ");
			c.gridx=3;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.skill_scoring+"");
			c.gridx=4;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.skill_passing+"");
			c.gridx=5;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.skill_rebounds+"");
			c.gridx=6;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.skill_defense+"");
			c.gridx=7;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(" |  ");
			c.gridx=8;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.seasons_left_contract+"");
			if (p.seasons_left_contract==1)desc.setForeground(orange);
			c.gridx=9;c.gridy=i+4;jp.add(desc,c);
			if (p.real())  {
				checkbox1[i]=new JCheckBox();
				checkbox1[i].setName((100+i)+"");
				checkbox1[i].addActionListener(checkListener);
				c.gridx=10;c.gridy=i+4;jp.add(checkbox1[i],c);	
			}
		}
		
		//trade button
		trade=new JButton("Trade");
		trade.addActionListener(tradeListener);
		c.gridx=11;c.gridy=1;jp.add(trade,c);	
		
		desc= new JLabel(" Name ");
		c.gridx=12+0;c.gridy=3;jp.add(desc,c);
		desc= new JLabel(" POS ");
		c.gridx=12+1;c.gridy=3;jp.add(desc,c);
		desc= new JLabel(" Age ");
		c.gridx=12+2;c.gridy=3;jp.add(desc,c);
		
		desc= new JLabel(" |  ");
		c.gridx=12+3;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("sco. ");
		c.gridx=12+4;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("pas. ");
		c.gridx=12+5;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("reb. ");
		c.gridx=12+6;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("def. ");
		c.gridx=12+7;c.gridy=3;jp.add(desc,c);
		desc= new JLabel(" |  ");
		c.gridx=12+8;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("yrs_left.");
		c.gridx=12+9;c.gridy=3;jp.add(desc,c);
		desc= new JLabel("  trade  ");
		c.gridx=12+10;c.gridy=3;jp.add(desc,c);
		
		for (int i=0;i<15;i++){
			cb1[i]=false;
			Player p=opponent.players[i];
			String fn="";
			if (p.firstname.length()>1)fn=p.firstname.substring(0, 1)+".";
			desc= new JLabel(fn+" "+p.lastname);
			c.gridx=12+0;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(positions[p.position]);
			c.gridx=12+1;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.age+"");
			c.gridx=12+2;c.gridy=i+4;jp.add(desc,c);
			
			desc= new JLabel(" |  ");
			c.gridx=12+3;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.skill_scoring+"");
			c.gridx=12+4;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.skill_passing+"");
			c.gridx=12+5;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.skill_rebounds+"");
			c.gridx=12+6;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.skill_defense+"");
			c.gridx=12+7;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(" |  ");
			c.gridx=12+8;c.gridy=i+4;jp.add(desc,c);
			desc= new JLabel(p.seasons_left_contract+"");
			if (p.seasons_left_contract==1)desc.setForeground(orange);
			c.gridx=12+9;c.gridy=i+4;jp.add(desc,c);
			if (p.real()){
				checkbox2[i]=new JCheckBox();
				checkbox2[i].setName((200+i)+"");
				checkbox2[i].addActionListener(checkListener);
				c.gridx=12+10;c.gridy=i+4;jp.add(checkbox2[i],c);	
			}
		}
		
	}
	

	private ActionListener teamListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int i = ((JComboBox)e.getSource()).getSelectedIndex();
			_main.mainpanel.removeAll();
			_main.mainpanel.add(new GameTrade(_main, i));
			_main.repaint();
			
		}
	};
	private ActionListener tradeListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int v1=0;
			int v2=0;
			int[] out=new int[sel(cb1)];
			int[] in=new int[sel(cb2)];
			Player[] t1players=new Player[sel(cb1)];
			Player[] t2players=new Player[sel(cb2)];
			int count1=0;
			int count2=0;
			for (int i=0;i<15;i++){
				if (cb1[i]){
					v1+=Math.pow(1.25,team.players[i].overallValue()/100.0);
					out[count1]=i;
					t1players[count1]=team.players[i];
					count1++;
				}
				if (cb2[i]) {
					v2+=Math.pow(1.25,opponent.players[i].overallValue()/100.0);
					in[count2]=i;
					t2players[count2]=opponent.players[i];
					count2++;
				}
			
			}
			if (v1*1.2>v2) {
				for (int i=0;i<out.length;i++){
				team.players[out[i]]=new Player();
				}
				for (int i=0;i<in.length;i++){
					opponent.players[in[i]]=new Player();
				}
				for (int i=0;i<in.length;i++){
					team.findRosterSpot(t2players[i], _main.league);
				}
				for (int i=0;i<out.length;i++){
					opponent.findRosterSpot(t1players[i], _main.league);
				}
				team.optimizeRoster();
				opponent.optimizeRoster();
				_main.mainpanel.removeAll();
				_main.mainpanel.add(new GameTrade(_main, showteam));
				_main.repaint();
				
			}
			else if(v1*10<v2){
				InfoDialog.message("That won't happen. Are you ****ing kidding me?", "Trade proposal rejected",_main);
			}
			else if (v1*2>v2){
				InfoDialog.message("That won't happen. But you are close!", "Trade proposal rejected",_main);
					
			}
			else {
				InfoDialog.message("That won't happen. No Way", "Trade proposal rejected",_main);
			}
			
		}
	};
	private ActionListener checkListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int i = Integer.parseInt(((JCheckBox)e.getSource()).getName());
			if (i/100==1){
				cb1[Func.mod(i, 100)]=!cb1[Func.mod(i, 100)];
			}
			if (i/100==2){
				cb2[Func.mod(i, 100)]=!cb2[Func.mod(i, 100)];
			}
			int diff=sel(cb2)-sel(cb1);
			if(diff>team.freeSpots()) {
				trade.setEnabled(false);
			}
			else if(-diff>opponent.freeSpots()) {
				trade.setEnabled(false);
			}
			else trade.setEnabled(true);
			
			
		}
	};
	
	private int sel(boolean [] v){
		int counter=0;
		for (int i=0;i<v.length;i++){
			if (v[i]) counter++;
		}
		return counter;
		
	}
	
}
