package dialogs;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JScrollPane;

public class HelpButton extends JButton {
	
	public static int ROSTER = 5;
	public static int DRAFT = 1;
	public static int TRADES = 2;
	public static int BEFOREGAME = 3;
	public static int FA = 4;
	public static int CONTRACTS =6 ;
	public static int GENERAL =0 ;
	
	
	private static Color orange = new Color(240,120,0);
	private static Color green = new Color(0,200,0);
	private static Color red = new Color(255,0,0);
	private static Color blue = new Color(0,0,200);
	private static Color yellow = new Color(255,250,200);
	
	private static Font smaller = new Font("SansSerif", Font.PLAIN, 10);
	private GameMain _main;
	public int state;
	public HelpButton(GameMain m) {
		super("-");
		_main=m;
		setForeground(green);
		setFont(smaller);
		addActionListener(listener);
		updateState(ROSTER);
	}
	public void updateState(int s) {
		state=s;
		if (state == ROSTER) setText("HELP (roster)");
		if (state == DRAFT) setText("HELP (draft)");
		if (state == TRADES) setText("HELP (trade)");
		if (state == FA) setText("HELP (free agents)");
		if (state == BEFOREGAME) setText("HELP (match)");
		if (state == CONTRACTS) setText("HELP (contracts)");
		
	}
	private ActionListener listener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			JFrame jep;
			try {
				jep = new JFrame("pb08 - quickhelp");
				jep.setSize(500, 500);
				
				String[] text = new String[7];
				text[GENERAL] ="";
				text[ROSTER] = "ROSTER SCREEN\n \n" +
						"Here you can modify your roster. \n"+
						"The abbreviations have the following meaning:\n"+
						"PG, SG, SF, PF, C = Starting 5 (point guard, shooting guard, small forward, power forward, center)\n"+
						"pg, sg, sf, pf, c = Bench players. Those 10 first slots contribute to the result of a game.\n"+
						"slots 11-15 are reserves that will get NO PLAYING TIME in the game \n \n"+
						"sco:  Scoring skills of the player. 1 is worst and 10 is best\n"+
						"pas: Passing skills (Very important for point guards)\n"+
						"reb: Rebounding skills (Important for PF and C)\n"+
						"def: Defense skills\n \n"+
						"NRG: 'energy'. Does not affect the effectiveness of the player, but if it drops below one, the player will lose skills. So give your players rest from time to time by benching them.\n"+
						"CON. 'confidence'. Team success and playing time makes a player more confident. Just like 'energy', make sure the value does not drop below one, or the player will become worse!\n "+
						"If both energy is at least 20 and confidence at least 50, the player will improve!\n \n"+
						"true position: It is preferable to let your players play their real position. Otherwise they will be less effective."

						;
				text[DRAFT] = "DRAFT SCREEN\n \n" +
						"In the draft, the teams get to choose new players from a pool \n" +
						"youngsters. The worst teams from last season get to choose first.\n \n"+
					"To choose a player, click on the small button at the end of the row\n" +
					"IMPORTANT: There are more players to choose\n" +
					"from than you can see on the first page. With\n" +
					"the '1','2', etc buttons on the top left corner you\n" +
					"can view the other pages. \n\n " +
					"You can NOT discard a draft pick. If you do not want to use a rookie,\n" +
					"select one and then select '(none)' when asked which player to replace.";
				text[CONTRACTS] = "CONTRACT SCREEN \n \n" +
						"Here you can extend the contract of your players or release them. \n" +
						"WAIVE: This is rather simple. It won't cost you anything, but you don't\n" +
						"get any refunds neither. Use it to free up roster spots for trades or free agents\n\n"+
						"SIGN/EXTEND: If you have good young players, extend them as soon as possible, as" +
						"they will become more expensive as they improve. In this game, you just pay in cash,"+
						"and you do not have to worry about a salary cap and unmovable contracts.";
				text[FA] ="FREE AGENTS SCREEN \n \n"+
						"They are some simple rules for Free Agents: You need enough money, and you need\n" +
						"an open roster spot. The player is payed in cash, without salary cap \n" +
						"restrictions to consider.\n \n" +
						"You can order the players by name, age, position and their overall value.";
				text[TRADES] = "TRADE SCREEN \n\n" +
							"You can trade players from your team to other teams\n" +
							"in exchange for their players. Just click on the checkbox\n" +
							"next to the player's name and click trade. IF the trade is \n" +
							"accepted, it will be done immediatly. Otherwise the system will\n" +
							"tell you if you were close to reaching an agreement.";
				text[BEFOREGAME] = "BEFORE_GAME SCREEN \n\n" +
							"Here you see your roster and your opponent's players. As only\n" +
							"the 10 top spots are used in a game, the others are not displayed.\n" +
							"You can adjust your lineup to your opponent, i.e. guard the best scorer\n" +
							"with your best defender." +
							"Click 'Start' to start the match. It will be simulated and the resulting \n" +
							"box score will be shown. \n\n" +
							"IMPORTANT: This is how the values for Energy (NRG) and \n" +
							"Confidence (CON) will change after the game:\n" +
							"Starting5: {NRG -2} {CON +3}\n" +
							"Backups (pg-c):  {NRG +1} {CON +1}\n" +
							"Reserve (11-15): {NRG +5} {CON -2}\n" +
							"A win gives all players who played in the game {CON +1}";
					
						
						
				JEditorPane htmlPane = new JEditorPane("HTTP", text[state]);
				htmlPane.setEditable(false);
				jep.add(new JScrollPane(htmlPane));
				jep.setVisible(true);
			}catch (Exception ex) {System.err.println(ex.getLocalizedMessage());}
			
			
		}
	};
}
