package dialogs;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;

import main.*;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class LeagueDialog extends JFrame{
	private JPanel jp;
	private JPanel jp2;
	private JList teamlist;
	private JList conflist;
	private LeagueDialog window;
	private JTextField filename;
	private JTextField leaguename;
	private JTextField conference_numbers;
	//public int[] teams_conference;
	private JTextField playoff_teams_par_conference;
	private JTextField[] confnames = new JTextField[4];
	private JTextField number_of_meetings;
	private JTextField best_of_x_in_playoffs;
	private JCheckBox play_other_conferences_in_rs;
	private boolean play_other_conferences_in_rs_boolean; 
	private Team[] teams = new Team[0];
	private JButton[] teamsinconf = new JButton[8];
	private League league;
	private int[] team_conferences = new int[0];
	private String[] positions = {"-", "PG", "SG", "SF", "PF", "C", "pg", "sg", "sf", "pf", "c", "11", "12", "13", "14", "15" };
	public LeagueDialog(League league) {
		super("Edit: "+league.league_name);
		this.league=league;
		showDialog(league);
	}
	
	public LeagueDialog() {
		super("Create new League");
		league = new League();
		showDialog(league);
	}
	private void showDialog(League league){
		window=this;
		team_conferences = new int[league.teams.length];
		for (int i=0;i<team_conferences.length;i++){
			team_conferences[i] = league.teams_conference[i];
		}
		play_other_conferences_in_rs_boolean = league.play_other_conferences_in_rs;
		this.setSize(900, 600);
		this.setLocation(50, 50);
		GridBagLayout gridbag=new GridBagLayout();
	
		setLayout(gridbag);
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.BOTH;
		jp = new JPanel();
		c.gridx = 0; c.gridy = 0; this.add(jp);
		GridBagLayout gridbag2=new GridBagLayout();
		
		jp.setLayout(gridbag2);
		GridBagConstraints c2 = new GridBagConstraints();
		int i = 0;
		JLabel desc = new JLabel("File Name");
		c2.gridx = 0; c2.gridy = i; jp.add(desc, c2);
		filename= new JTextField(league.filename, 15);
		c2.gridx = 1; c2.gridy = i; jp.add(filename, c2);
		i++;
		
		desc = new JLabel("League Name");
		c2.gridx = 0; c2.gridy = i; jp.add(desc, c2);
		leaguename= new JTextField(league.league_name+"", 10);
		c2.gridx = 1; c2.gridy = i; jp.add(leaguename, c2);
		i++;
		
		desc = new JLabel("Number of Conferences");
		c2.gridx = 0; c2.gridy = i; jp.add(desc, c2);
		conference_numbers= new JTextField(league.conference_numbers+"", 5);
		c2.gridx = 1; c2.gridy = i; jp.add(conference_numbers, c2);
		i++;
		
		desc = new JLabel("Playoff-Teams each conference");
		c2.gridx = 0; c2.gridy = i; jp.add(desc, c2);
		playoff_teams_par_conference= new JTextField(league.playoff_teams_par_conference+"", 5);
		c2.gridx = 1; c2.gridy = i; jp.add(playoff_teams_par_conference, c2);
		i++;
		
		desc = new JLabel("Play teams from other conferences(RS)");
		c2.gridx = 0; c2.gridy = i; jp.add(desc, c2);
		play_other_conferences_in_rs= new JCheckBox(" ", play_other_conferences_in_rs_boolean);
		play_other_conferences_in_rs.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (play_other_conferences_in_rs_boolean) play_other_conferences_in_rs_boolean = false;
				else play_other_conferences_in_rs_boolean = true;
			}
		});
		c2.gridx = 1; c2.gridy = i; jp.add(play_other_conferences_in_rs, c2);
		i++;

		desc = new JLabel("Number of Meetings (RS)");
		c2.gridx = 0; c2.gridy = i; jp.add(desc, c2);
		number_of_meetings= new JTextField(league.number_of_meetings+"", 5);
		c2.gridx = 1; c2.gridy = i; jp.add(number_of_meetings, c2);
		i++;
		
		desc = new JLabel("Playoffs: Best of _");
		c2.gridx = 0; c2.gridy = i; jp.add(desc, c2);
		best_of_x_in_playoffs= new JTextField(league.best_of_x_in_playoffs+"", 5);
		c2.gridx = 1; c2.gridy = i; jp.add(best_of_x_in_playoffs, c2);
		i++;

		desc = new JLabel("--- Conference Names");
		c2.gridx = 0; c2.gridy = i; jp.add(desc, c2);
		i++;
		for (int j = 0;j<confnames.length;j++) {
			desc = new JLabel("         "+j+".");
			c2.gridx = 0; c2.gridy = i; jp.add(desc, c2);
			String v="";
			if (j<league.conference_names.length) {
				v =league.conference_names[j];
			}
			confnames[j]= new JTextField(v, 10);
			c2.gridx = 1; c2.gridy = i; jp.add(confnames[j], c2);
			teamsinconf[j] = new JButton("set");
			teamsinconf[j].setName(j+"");
			teamsinconf[j].addActionListener(setTeamsConferenceListener);
			c2.gridx = 2; c2.gridy = i; jp.add(teamsinconf[j], c2);
			
			i++;
		}
		
		
	
		
		JButton abort = new JButton("Abort");
		abort.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				window.dispose();
			}
		});
		c2.gridx = 0; c2.gridy = 15; jp.add(new JLabel("-"), c2);

		c2.gridx = 1; c2.gridy =15; jp.add(new JLabel("-"), c2);
		c2.gridx = 0; c2.gridy = 16; jp.add(abort, c2);
		JButton save = new JButton("Save");
		save.addActionListener(saveListener);
		c2.gridx = 1; c2.gridy =16; jp.add(save, c2);
	
		

		i=0;
		jp2 = new JPanel();
		c.gridx = 1; c.gridy = 0; this.add(jp2);
		GridBagLayout gridbag3=new GridBagLayout();
		jp2.setLayout(gridbag3);
		GridBagConstraints c3 = new GridBagConstraints();
		
		teams = league.teams;
		String[] teamnames = new String[teams.length];
		String[] conf_names = new String[teams.length];
		for (int j =0;j<teamnames.length;j++) {
			teamnames[j] = teams[j].name;
			conf_names[j] = confnames[team_conferences[j]].getText();
		}
		teamlist = new JList(teamnames);
		c3.gridx = 0; c3.gridy = i; jp2.add(teamlist, c3);
		
		conflist = new JList(conf_names);
		c3.gridx = 1; c3.gridy = i; jp2.add(conflist, c3);
		
		i++;
		
		JButton loadteams = new JButton("Load Teams");
		loadteams.addActionListener(load_teams);
		c3.gridx = 0; c3.gridy = i; jp2.add(loadteams, c3);
		

		
		
		
		this.setVisible(true);
	}
	
	private void update() {
		String[] teamnames = new String[teams.length];
		String[] conf_names = new String[teams.length];
		for (int i =0;i<teamnames.length;i++) {
			teamnames[i] = teams[i].name+" ("+teams[i].avg_rating()+")";
			conf_names[i] = confnames[team_conferences[i]].getText();
		}
		teamlist.setListData(teamnames);
		conflist.setListData(conf_names);
		
	}
	
	private ActionListener saveListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			League l = new League();
			l.best_of_x_in_playoffs = Integer.parseInt(best_of_x_in_playoffs.getText());
			l.conference_numbers = Integer.parseInt(conference_numbers.getText());
			l.conference_names = new String[l.conference_numbers];
			for (int i =0;i<l.conference_numbers;i++) {
				l.conference_names[i] = confnames[i].getText();
			}
			l.filename = filename.getText();
			l.number_of_meetings = Integer.parseInt(number_of_meetings.getText());
			l.play_other_conferences_in_rs = play_other_conferences_in_rs_boolean;
			l.playoff_teams_par_conference = Integer.parseInt(playoff_teams_par_conference.getText());
			l.teams = teams;
			l.teams_conference = new int[teams.length];
			for (int i=0;i<l.teams_conference.length;i++) {
				l.teams_conference[i] = team_conferences[i];
			}
			
			File outputfile = new File("data/leagues/"+filename.getText()+".pb08");
			if (outputfile.exists()) {
				
			}
			else {
				try {
					outputfile.createNewFile();
				} catch (IOException ex){System.err.println(ex.getMessage());}
			}
			
			League.writeLeague(outputfile, l);
		}
		
	};
	
	private ActionListener setTeamsConferenceListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int number = Integer.parseInt(((JButton)e.getSource()).getName());
			int[] selected = teamlist.getSelectedIndices();
			for (int i=0;i<selected.length;i++) {
				team_conferences[selected[i]] = number;

			}
			window.update();
			
		}
		
	};

	
	private ActionListener load_teams = new ActionListener() {
		public void actionPerformed(ActionEvent e) {

			JFileChooser chooser = new JFileChooser("data/teams/");
			chooser.setMultiSelectionEnabled(true);
			int returnVal = chooser.showOpenDialog(null);			
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				
				
				File[] files = chooser.getSelectedFiles();
				teams = new Team[files.length];
				team_conferences = new int[files.length];
				for (int i=0;i<files.length;i++) {
					teams[i] = Team.fromFile(files[i]);
				}
				window.update();
			}
		
		}
	};


	
}
