package dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

import main.Player;


public class PlayerDialog extends JFrame{
	private TeamDialog src;
	private int player_nr_src;
	private JTextField filename;
	private JTextField lastname;
	private JTextField firstname;
	private JTextField position;
	private JTextField age;
	private JTextField scoring;
	private JTextField passing;
	private JTextField rebounds;
	private JTextField defense;
	private JTextField seasons;
	private JTextField seasons_left_contract;
	private JTextField annual_salary;
	private Player p;
	
	private PlayerDialog window;
	public PlayerDialog() {
		super("Create new Player");
		createdialog(new Player(), null);
	}
	public PlayerDialog(Player player, String filestr) {
		super("Edit Player: "+player.lastname);
		createdialog(player, filestr);
	}
	private void createdialog(Player player, String filestr) {
		window=this;
		this.p=player;
		this.setSize(500, 400);
		this.setLocation(200, 200);
		GridBagLayout gridbag=new GridBagLayout();
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		int i = 0;
		c.fill = GridBagConstraints.BOTH;
		
		JLabel desc = new JLabel("File Name");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		String str ="";
		if (filestr != null && filestr.length()>4) str = filestr.substring(0, filestr.length()-5);
		filename= new JTextField(str);
		c.gridx = 1; c.gridy = i; this.add(filename, c);
		filename.setEnabled(false);
		i++;
				
		desc = new JLabel("Last Name");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		lastname= new JTextField(p.lastname);
		c.gridx = 1; c.gridy = i; this.add(lastname, c);
		i++;
		
		desc = new JLabel("First Name");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		firstname= new JTextField(p.firstname);
		c.gridx = 1; c.gridy = i; this.add(firstname, c);
		i++;

		desc = new JLabel("Position (1,2,3,4,5)");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		position= new JTextField(p.position+"");
		c.gridx = 1; c.gridy = i; this.add(position, c);
		i++;
		
		desc = new JLabel("Age (years)");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		age= new JTextField(p.age+"");
		c.gridx = 1; c.gridy = i; this.add(age, c);
		i++;
		
		desc = new JLabel("Years Pro(0 = Rookie)");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		seasons= new JTextField(p.seasons+"");
		c.gridx = 1; c.gridy = i; this.add(seasons, c);
		i++;	
		
		
		//May be re-added later!
		desc = new JLabel("Years Left on Contract");
		//c.gridx = 0; c.gridy = i; this.add(desc, c);
		seasons_left_contract= new JTextField(p.seasons_left_contract+"");
		//c.gridx = 1; c.gridy = i; this.add(seasons_left_contract, c);
	
		i++;
		
		desc = new JLabel("Annual Salary");
		//c.gridx = 0; c.gridy = i; this.add(desc, c);
		annual_salary= new JTextField(p.annual_salary+"");
		//c.gridx = 1; c.gridy = i; this.add(annual_salary, c);
		i++;	
		
		
		desc = new JLabel("Rating: ");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		desc = new JLabel("0=worst. 10=best");
		c.gridx = 1; c.gridy = i; this.add(desc, c);
		i++;
	
		desc = new JLabel(" . scoring");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		scoring= new JTextField(p.skill_scoring+"");
		c.gridx = 1; c.gridy = i; this.add(scoring, c);
		i++;
		
		desc = new JLabel(" . passing");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		passing= new JTextField(p.skill_passing+"");
		c.gridx = 1; c.gridy = i; this.add(passing, c);
		i++;
		
		desc = new JLabel(" . rebounds");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		rebounds= new JTextField(p.skill_rebounds+"");
		c.gridx = 1; c.gridy = i; this.add(rebounds, c);
		i++;
		
		desc = new JLabel(" . defense");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		defense= new JTextField(p.skill_defense+"");
		c.gridx = 1; c.gridy = i; this.add(defense, c);
		i++;

		
		JButton abort = new JButton("Abort");
		abort.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				window.dispose();
			}
		});
		c.gridx = 0; c.gridy = i; this.add(abort, c);
		
		JButton save = new JButton("Save");
		save.addActionListener(saveListener);
		c.gridx = 1; c.gridy = i; this.add(save, c);

		i++;
		
	
		this.setVisible(true);
	}
	
	
	private ActionListener saveListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			String fn =filename.getText();
			if (fn == "") {}
			fn = (lastname.getText()+"_"+firstname.getText()).replace(' ', '_');
			File outputfile = new File("data/players/"+fn+".pb08");
			if (outputfile.exists()) {
				
			}
			else {
				try {
					outputfile.createNewFile();
				} catch (IOException ex){System.err.println(ex.getMessage());}
			}
			p.age=Integer.parseInt(age.getText());

			p.lastname =lastname.getText();
			p.firstname = firstname.getText();
			p.position = Integer.parseInt(position.getText());
			p.age=Integer.parseInt(age.getText());
			p.skill_scoring = Integer.parseInt(scoring.getText());
			p.skill_passing = Integer.parseInt(passing.getText());
			p.skill_rebounds = Integer.parseInt(rebounds.getText());
			p.skill_defense = Integer.parseInt(defense.getText());
			p.seasons =Integer.parseInt(seasons.getText());
			p.seasons_left_contract = Integer.parseInt(seasons_left_contract.getText());
			p.annual_salary = Integer.parseInt(annual_salary.getText()) ;
			p.special_abilities = 0;
			Player.writePlayer(outputfile,p);
			window.dispose();
	
		
		}
		
	};
	
	public void setSrcDialog(TeamDialog t, int nr){
		src=t;
		player_nr_src=nr;
	}

}
