package dialogs;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import main.*;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;


public class TeamDialog extends JFrame{
	private TeamDialog window;
	private JTextField filename;
	private JTextField teamname;
	private Team team;
	private JLabel[][] players;

	private String[] positions = {"-", "PG", "SG", "SF", "PF", "C", "pg", "sg", "sf", "pf", "c", "11", "12", "13", "14", "15" };
	public TeamDialog(Team team) {
		super("Edit: "+team.name);
		this.team=team;
		showDialog(team);
	}
	
	public TeamDialog() {
		super("Create new Team");
		team = new Team();
		showDialog(team);
	}
	private void showDialog(Team team){
		window=this;

		
		initiate();
		
		this.setSize(800, 600);
		this.setLocation(50, 50);
		GridBagLayout gridbag=new GridBagLayout();
	
		setLayout(gridbag);
		GridLayout layout = new GridLayout();
		GridBagConstraints c = new GridBagConstraints();
		
		int i = 0;
		c.fill = GridBagConstraints.BOTH;
		
		JLabel desc = new JLabel("File Name");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		filename= new JTextField(team.filename, 10);
		c.gridx = 1; c.gridy = i; this.add(filename, c);
		i++;
		
		desc = new JLabel("Team Name");
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		teamname= new JTextField(team.name);
		c.gridx = 1; c.gridy = i; this.add(teamname, c);
		i++;
		Font italic = desc.getFont().deriveFont(Font.ITALIC);
		desc = new JLabel("Position");
		
		c.gridx = 0; c.gridy = i; this.add(desc, c);
		desc= new JLabel("Name");
		c.gridx = 1; c.gridy = i; this.add(desc, c);
		desc= new JLabel("Age");
		c.gridx = 2; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = 3; c.gridy = i; this.add(desc, c);
		desc= new JLabel("sco.");
		c.gridx = 4; c.gridy = i; this.add(desc, c);
		desc= new JLabel("pas.");
		c.gridx = 5; c.gridy = i; this.add(desc, c);
		desc= new JLabel("reb.");
		c.gridx = 6; c.gridy = i; this.add(desc, c);
		desc= new JLabel("def.");
		c.gridx = 7; c.gridy = i; this.add(desc, c);
		desc= new JLabel("  |  ");
		c.gridx = 8; c.gridy = i; this.add(desc, c);
		desc= new JLabel("load");
		c.gridx = 9; c.gridy = i; this.add(desc, c);
		desc= new JLabel("move to");
		c.gridx = 10; c.gridy = i; this.add(desc, c);
		
		
		i++;
		
		
		for (int j=0;j<15;j++){
			
			c.gridx = 0; c.gridy = i; this.add(players[j][0], c);
			c.gridx = 1; c.gridy = i; this.add(players[j][1], c);
			c.gridx = 2; c.gridy = i; this.add(players[j][2], c);
			desc= new JLabel("  |  ");
			c.gridx = 3; c.gridy = i; this.add(desc, c);
			c.gridx = 4; c.gridy = i; this.add(players[j][3], c);
			c.gridx = 5; c.gridy = i; this.add(players[j][4], c);
			c.gridx = 6; c.gridy = i; this.add(players[j][5], c);
			c.gridx = 7; c.gridy = i; this.add(players[j][6], c);
			desc= new JLabel("  |  ");
			c.gridx = 8; c.gridy = i; this.add(desc, c);
			JButton chooseplayer = new JButton("open..");
			chooseplayer.setName(""+j);
			chooseplayer.addActionListener(load_player);
			c.gridx = 9; c.gridy = i; this.add(chooseplayer, c);
			
			JComboBox position_combo = new JComboBox(positions);
			
			position_combo.addActionListener(positionListener);
			position_combo.setName(""+j);
			c.gridx = 10; c.gridy = i; this.add(position_combo, c);
			JButton editplayer = new JButton("edit");
			editplayer.setName(""+j);
			editplayer.addActionListener(edit_player);
			c.gridx = 11; c.gridy = i; this.add(editplayer, c);
			
			
			i++;

		}
		i++;
		JButton abort = new JButton("Abort");
		abort.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				window.dispose();
			}
		});
		c.gridx = 0; c.gridy = i; this.add(abort, c);
		JButton save = new JButton("Save");
		save.addActionListener(saveListener);
		c.gridx = 1; c.gridy = i; this.add(save, c);
		
	
		this.setVisible(true);
	}
	
	private ActionListener saveListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			team.filename = filename.getText();
			team.name = teamname.getText();
			team.save();
		}
		
	};
	private void initiate() {
		players = new JLabel[15][8];
		
		for (int j=0;j<15;j++) {
			players[j][0]= new JLabel(positions[j+1]);

			players[j][1]= new JLabel(team.players[j].lastname.toUpperCase()+" "+team.players[j].firstname);
			players[j][2]= new JLabel(String.valueOf(team.players[j].age));		
			players[j][3]= new JLabel(String.valueOf(team.players[j].skill_scoring));
			players[j][4]= new JLabel(String.valueOf(team.players[j].skill_passing));
			players[j][5]= new JLabel(String.valueOf(team.players[j].skill_rebounds));
			players[j][6]= new JLabel(String.valueOf(team.players[j].skill_defense));

		}
	}
	public void update_player(int j, File file) {
		team.players[j] = Player.readPlayer(file);
		team.playerfiles[j] = file.getName().substring(0, file.getName().length()-5);
		window.update();
	}
	private void update() {

		
	 	for (int j=0;j<15;j++) {

			players[j][0].setText(positions[j+1]);
			players[j][1].setText(team.players[j].lastname.toUpperCase()+" "+team.players[j].firstname);
			players[j][2].setText(String.valueOf(team.players[j].age));		
			players[j][3].setText(String.valueOf(team.players[j].skill_scoring));
			players[j][4].setText(String.valueOf(team.players[j].skill_passing));
			players[j][5].setText(String.valueOf(team.players[j].skill_rebounds));
			players[j][6].setText(String.valueOf(team.players[j].skill_defense));

		}
	}
	
	
	private ActionListener load_player = new ActionListener() {
		public void actionPerformed(ActionEvent e) {

			JFileChooser chooser = new JFileChooser("data/players/");
			int j = Integer.parseInt(((JButton)e.getSource()).getName());
			int returnVal = chooser.showOpenDialog(null);			
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				
				
				File file = chooser.getSelectedFile();
				team.players[j] = Player.readPlayer(file);
				team.playerfiles[j] = file.getName().substring(0, file.getName().length()-5);
				window.update();
			}
		
		}
	};
	private ActionListener edit_player = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int j = Integer.parseInt(((JButton)e.getSource()).getName());
			File file = new File("data/players/"+team.playerfiles[j]+".pb08");
			PlayerDialog npd = new PlayerDialog(Player.readPlayer(file),file.getName());
			npd.setSrcDialog(window, j);
		
		
		}
	};
	private ActionListener positionListener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			int i = ((JComboBox)e.getSource()).getSelectedIndex()-1;
			int j = Integer.parseInt(((JComboBox)e.getSource()).getName());
			if (i>=0) {
				Player tmpplayer = team.players[i];
				team.players[i] = team.players[j];
				team.players[j] = tmpplayer;
				String tmpname = team.playerfiles[i];
				team.playerfiles[i] = team.playerfiles[j];
				team.playerfiles[j] = tmpname;
				window.update();
			}
		}
	};
	
}
