package main;
import dialogs.*;
public class BoxScore {
	private static int C = 5;
	private static int PF = 4;
	private static int SF = 3;
	private static int SG = 2;
	private static int PG = 1;
	private static int C2 = 10;
	private static int PF2 = 9;
	private static int SF2 = 8;
	private static int SG2 = 7;
	private static int PG2 = 6;
	
	private int points_Team1;
	private int points_Team2;
	public int[] points1;
	public int[] points2;
	public int[] assists1;
	public int[] assists2;
	public int[] rebounds1;
	public int[] rebounds2;
	private Team team1;
	private Team team2;
	private int[] skill_defense1 = new int[10];
	private int[] skill_defense2 = new int[10];
	private int[] skill_rebounds1 = new int[10];
	private int[] skill_rebounds2 = new int[10];
	private int[] skill_scoring1 = new int[10];
	private int[] skill_scoring2 = new int[10];
	private int[] skill_passing1 = new int[10];
	private int[] skill_passing2 = new int[10];
	
	public BoxScore(Team team1, Team team2, boolean penalty_position) {
		this.team1=team1;
		this.team2=team2;
		
		for (int i=0;i<10;i++) {
			skill_rebounds1[i] = team1.players[i].skill_rebounds;
			skill_rebounds2[i] = team2.players[i].skill_rebounds;
			skill_passing1[i] = team1.players[i].skill_passing;
			skill_passing2[i] = team2.players[i].skill_passing;
			skill_scoring1[i] = team1.players[i].skill_scoring;
			skill_scoring2[i] = team2.players[i].skill_scoring;
			skill_defense1[i] = team1.players[i].skill_defense;
			skill_defense2[i] = team2.players[i].skill_defense;
			
		}
		if (penalty_position) calculate_handycap();
		calculate();
	}
	private void calculate_handycap() {
		for (int i =0;i<10;i++) {
			
			//missed true position by one spot: C at PF, PG at SG ...
			if (i+1 != team1.players[i].position && i-4 != team1.players[i].position) { 
				if (skill_scoring1[i]>0) skill_scoring1[i]--; 
				if (skill_defense1[i]>0) skill_defense1[i]--;
				if (skill_rebounds1[i]>0) skill_rebounds1[i]--;
				
				//missed true position by two or more spots: Additional penalty
				if ((((i+1 == C) || (i+1 == C2) )&& (team1.players[i].position != PF)) ||
					(((i+1 == PF) || (i+1 == PF2) )&& (team1.players[i].position != SF && team1.players[i].position != C)) ||
					(((i+1 == SF) || (i+1 == SF2) )&& (team1.players[i].position != SG && team1.players[i].position != PF)) ||
					(((i+1 == SG) || (i+1 == SG2) )&& (team1.players[i].position != PG && team1.players[i].position != SF)) ||
					(((i+1 == PG) || (i+1 == PG2) )&& (team1.players[i].position != SG))) { 
					
					if (skill_scoring1[i]>0) skill_scoring1[i]--; 
					if (skill_defense1[i]>0) skill_defense1[i]--;
					if (skill_rebounds1[i]>0) skill_rebounds1[i]--;
					if (skill_passing1[i]>0) skill_passing1[i]--;
				}
				
			}
			if (i+1 != team2.players[i].position && i-4 != team2.players[i].position && skill_scoring2[i]>0) { 
				if (skill_scoring2[i]>0) skill_scoring2[i]--; 
				if (skill_defense2[i]>0) skill_defense2[i]--;
				if (skill_rebounds2[i]>0) skill_rebounds2[i]--;
				//missed true position by two or more spots: Additional penalty
				if ((((i+1 == C) || (i+1 == C2) )&& (team2.players[i].position != PF)) ||
					(((i+1 == PF) || (i+1 == PF2) )&& (team2.players[i].position != SF && team2.players[i].position != C)) ||
					(((i+1 == SF) || (i+1 == SF2) )&& (team2.players[i].position != SG && team2.players[i].position != PF)) ||
					(((i+1 == SG) || (i+1 == SG2) )&& (team2.players[i].position != PG && team2.players[i].position != SF)) ||
					(((i+1 == PG) || (i+1 == PG2) )&& (team2.players[i].position != SG))) { 
					if (skill_scoring2[i]>0) skill_scoring2[i]--; 
					if (skill_defense2[i]>0) skill_defense2[i]--;
					if (skill_rebounds2[i]>0) skill_rebounds2[i]--;
					if (skill_passing2[i]>0) skill_passing2[i]--;
					
				}
				
			
			}
			if (team1.players[i].special_status == EventDialog.INJURY) {
				skill_scoring1[i]=1; 
				skill_defense1[i]=1;
				skill_rebounds1[i]=1;
				skill_passing1[i]=1;
			}
		}
	}
	
	private void calculate() {
		int team1_defense =0;
		for (int i = 0;i<10;i++) {
			if (i<5) team1_defense+=skill_defense1[i]*2;
			else team1_defense+=skill_defense1[i];
		}
		int team2_defense =0;
		for (int i = 0;i<10;i++) {
			if (i<5) team2_defense+=skill_defense2[i]*2;
			else team2_defense+=skill_defense2[i];
		}
		
		points1 = new int[10];
		points2 = new int[10];
		assists1 = new int[10];
		assists2= new int[10];
		rebounds1 = new int[10];
		rebounds2 = new int[10];
		
		//rebounds:
		
		int pos;
		for (int i=0;i<100;i++) {
			double rnd = Math.random()*29;
			if (rnd < 5) pos=C;
			else if (rnd < 10) pos=PF;
			else if (rnd < 14) pos=SF;
			else if (rnd < 17) pos=SG;
			else if (rnd < 19) pos=PG;
			else if (rnd < 22) pos=C2;
			else if (rnd < 25) pos=PF2;
			else if (rnd < 27) pos=SF2;
			else if (rnd < 28) pos=SG2;
			else pos = PG2;
			
			int sum = (int)Math.pow(skill_rebounds1[pos-1], 1.5)+(int)Math.pow(skill_rebounds2[pos-1], 1.5);
			rnd = Math.random()*sum;
			if (rnd<Math.pow(skill_rebounds1[pos-1],1.5)) rebounds1[pos-1]++;
			else rebounds2[pos-1]++;
		}
		
		int possessions1 = 0;
		int possessions2 = 0;
			
		for (int i=0;i<10;i++) {
			possessions1 += rebounds1[i];
			possessions2 +=rebounds2[i];
		}
		
		//points on 1on1 situations
		for (int i=0;i<20+possessions1;i++) {
			double rnd = Math.random()*15;
			if (rnd < 2) pos=C;
			else if (rnd < 4) pos=PF;
			else if (rnd < 6) pos=SF;
			else if (rnd < 8) pos=SG;
			else if (rnd < 10) pos=PG;
			else if (rnd < 11) pos=C2;
			else if (rnd < 12) pos=PF2;
			else if (rnd < 13) pos=SF2;
			else if (rnd < 14) pos=SG2;
			else pos = PG2;
			
			int sum = sq(skill_scoring1[pos-1])+sq(skill_defense2[pos-1]+1);
			rnd = Math.random()*sum;
			if (rnd<sq(skill_scoring1[pos-1])) points1[pos-1]+=1 + Func.mod((int)rnd,2);
		}
		for (int i=0;i<20+possessions2;i++) {
			double rnd = Math.random()*15;
			if (rnd < 2) pos=C;
			else if (rnd < 4) pos=PF;
			else if (rnd < 6) pos=SF;
			else if (rnd < 8) pos=SG;
			else if (rnd < 10) pos=PG;
			else if (rnd < 11) pos=C2;
			else if (rnd < 12) pos=PF2;
			else if (rnd < 13) pos=SF2;
			else if (rnd < 14) pos=SG2;
			else pos = PG2;
			
			int sum = sq(skill_scoring2[pos-1])+sq(skill_defense1[pos-1]+1);
			rnd = Math.random()*sum;
			if (rnd<sq(skill_scoring2[pos-1])) points2[pos-1]+=1 + Func.mod((int)rnd, 2);
		}
		//assisted points:
		for (int i=0;i<15+possessions1;i++) {
			double rnd = Math.random()*22;
			if (rnd < 1) pos=C;
			else if (rnd < 3) pos=PF;
			else if (rnd < 6) pos=SF;
			else if (rnd < 9) pos=SG;
			else if (rnd < 14) pos=PG;
			else if (rnd < 15) pos=C2;
			else if (rnd < 16) pos=PF2;
			else if (rnd < 17) pos=SF2;
			else if (rnd < 19) pos=SG2;
			else pos = PG2;
			
			
			int sum = sq(skill_passing1[pos-1])*2+team2_defense;
			rnd = Math.random()*sum;
			if (rnd<sq(skill_passing1[pos-1])*2) {
				
				
				int pos2;
				rnd = Math.random()*15;
				if (rnd < 2 && pos!=C) pos2=C;
				else if (rnd < 4 && pos!=PF) pos2=PF;
				else if (rnd < 6 && pos!=SF) pos2=SF;
				else if (rnd < 8 && pos!=SG) pos2=SG;
				else if (rnd < 10 && pos!= PG) pos2=PG;
				else if (rnd < 11 && pos!= C2) pos2=C2;
				else if (rnd < 12 && pos!= PF2) pos2=PF2;
				else if (rnd < 13 && pos!= SF2) pos2=SF2;
				else if (rnd < 14 && pos!= SG2) pos2=SG2;
				else pos2 = PG2;
				double rnd2= Math.random()*10;
				if (skill_scoring1[pos2-1]+3>rnd2) {
					assists1[pos-1]++;
					points1[pos2-1] +=2;
					if (Math.random()*2 >=1) points1[pos2-1]++;
				}
				
			}
		}
		
		//(team2 )
		for (int i=0;i<15+possessions2;i++) {
			double rnd = Math.random()*22;
			if (rnd < 1) pos=C;
			else if (rnd < 3) pos=PF;
			else if (rnd < 6) pos=SF;
			else if (rnd < 9) pos=SG;
			else if (rnd < 14) pos=PG;
			else if (rnd < 15) pos=C2;
			else if (rnd < 16) pos=PF2;
			else if (rnd < 17) pos=SF2;
			else if (rnd < 19) pos=SG2;
			else pos = PG2;
			
			
			int sum = sq(skill_passing2[pos-1])*2+team1_defense;
			rnd = Math.random()*sum;
			if (rnd<sq(skill_passing2[pos-1])*2) {
				
				int pos2;
				rnd = Math.random()*15;
				if (rnd < 2 && pos!=C) pos2=C;
				else if (rnd < 4 && pos!=PF) pos2=PF;
				else if (rnd < 6 && pos!=SF) pos2=SF;
				else if (rnd < 8 && pos!=SG) pos2=SG;
				else if (rnd < 10 && pos!= PG) pos2=PG;
				else if (rnd < 11 && pos!= C2) pos2=C2;
				else if (rnd < 12 && pos!= PF2) pos2=PF2;
				else if (rnd < 13 && pos!= SF2) pos2=SF2;
				else if (rnd < 14 && pos!= SG2) pos2=SG2;
				else pos2 = PG2;
				double rnd2= Math.random()*10;
				if (skill_scoring2[pos2-1]+3>rnd2) {
					assists2[pos-1]++;
					points2[pos2-1] +=2;
					if (Math.random()*2 >=1) points2[pos2-1]++;
				}
			}
		}
		
		
		
		for (int i=0;i<10;i++) {
			points_Team1 += points1[i];
			points_Team2 +=points2[i];
		}
		// Equals score: "overtime"
		
		if (points_Team1==points_Team2) {
			double rnd = Math.random();
			if (rnd<0.5) {
				points1[1]++;
				points_Team1++;
			}
			else {
				points2[1]++;
				points_Team2++;
				
			}
		}
		
		
	}

	public void updateStats() {
		if (points_Team1 > points_Team2) {
			team1.games_won++;
			team1.score++;
			team1.credits+=50;
			team2.credits += 40;
			team2.games_lost++;
		}
		else {
			team2.games_won++;
			team2.score++;
			team2.credits+=50;
			team1.credits += 40;
			team1.games_lost++;
		}
		
		for (int i=0;i<10;i++) {
			team1.players[i].stats_assists += assists1[i];
			team1.players[i].stats_points += points1[i];
			team1.players[i].stats_rebounds += rebounds1[i];
			team1.players[i].stats_games++;
			
			team2.players[i].stats_assists += assists2[i];
			team2.players[i].stats_points += points2[i];
			team2.players[i].stats_rebounds += rebounds2[i];
			team2.players[i].stats_games++;
		}
		
	}
	public void updateValues(int t) {
		if (t==1) {
			for (int i=0;i<15;i++) {
				Player p = team1.players[i];
				if (p.real()) {
					if (i<5) p.energy=p.energy-2;
					else if (i<10) p.energy=p.energy+1;
					else p.energy = p.energy + 5; 
					
					if (i<5) p.confidence=p.confidence+3;
					else if (i<10) p.confidence=p.confidence+1;
					else p.confidence = p.confidence - 2;
					
					if (points_Team1>points_Team2 && i<10) p.confidence ++;
					
					
					if (p.confidence > 60) p.confidence=60;
					if (p.confidence<0) p.confidence =0;
					if (p.energy <0) p.energy=0;
					if (p.energy >25) p.energy =25;
				}
			}
		}
	}
	public int getPoints_Team1() {
		return points_Team1;
	}

	public int getPoints_Team2() {
		return points_Team2;
	}

	private int sq(int a) {
		return a*a;
	}
}
