package main;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Calendar;
import java.util.Date;

import dialogs.*;
public class Game {
	public int day;
	public int matchonday;
	public int season;

	public Team team;
	public Team[] opponents;
	public League league;
	public int season_phase = SEASON_REGULAR;
	public int po_round =1;
	public static int SEASON_REGULAR = 1;
	public static int SEASON_PLAYOFFS = 2;
	public static int SEASON_FINALS = 3;
	public static int SEASON_OFFSEASON = 0;
	public static int SEASON_DRAFT = 5;
	public static int SEASON_AFTER_RS = 6;
	public static int SEASON_AFTER_PO = 7;
	public static int SEASON_DURING_DRAFT = 8;

	
	public Game() {

		season =1;
		
		
	}

	// | --> seperator symbol

	public static boolean save(File file, GameMain _main) {
		try {
			FileOutputStream fos = new FileOutputStream(file);
			byte version = 0;
			fos.write(version);
			write(String.valueOf(_main.season), fos);
			write(String.valueOf(_main.day), fos);
			write(String.valueOf(_main.matchonday), fos);
			write(String.valueOf(_main.season_phase), fos);
			write(String.valueOf(_main.po_round), fos);
			saveTeam(_main.team, fos);
			write(String.valueOf(_main.opponents.length), fos);
			for (int i=0;i<_main.opponents.length;i++) {

				saveTeam(_main.opponents[i], fos);
			}
			saveLeague(_main.league, fos);
			fos.write('');
			

		fos.close();	
		} catch (Exception ex) {System.err.println(ex.getMessage()); return false;}
		
		return true;
	}
	private static void saveTeam(Team team, FileOutputStream fos) throws Exception {
		write(team.name, fos);

		write(String.valueOf(team.games_won), fos);
		write(String.valueOf(team.games_lost), fos);
		write(String.valueOf(team.deadsalary), fos);
		write(String.valueOf(team.credits), fos);
		write(String.valueOf(team.score), fos);
		write(String.valueOf(team.draftpicks.length), fos);
		for (int i=0;i<team.draftpicks.length;i++) {
			write(String.valueOf(team.draftpicks[i]), fos);
		}
		write(String.valueOf(team.futuredraftpicks.length), fos);
		for (int i=0;i<team.futuredraftpicks.length;i++) {
			write(String.valueOf(team.futuredraftpicks[i].year), fos);
			write(String.valueOf(team.futuredraftpicks[i].round), fos);
			write(String.valueOf(team.futuredraftpicks[i].team_number), fos);
			
		}
		for (int i =0;i<15;i++) {
			savePlayer(team.players[i], fos);
			
		}
	}
	
	private static void savePlayer(Player p, FileOutputStream fos) throws IOException {
		
		write(p.lastname, fos);
		write(p.firstname, fos);
		write(String.valueOf(p.position), fos);
		write(String.valueOf(p.age), fos);
		write(String.valueOf(p.seasons), fos);
		write(String.valueOf(p.seasons_left_contract), fos);
		write(String.valueOf(p.annual_salary), fos);
		
		write(String.valueOf(p.skill_scoring), fos);
		write(String.valueOf(p.skill_passing), fos);
		write(String.valueOf(p.skill_rebounds), fos);
		write(String.valueOf(p.skill_defense), fos);
		write(String.valueOf(p.stats_games), fos);
		write(String.valueOf(p.stats_points), fos);
		write(String.valueOf(p.stats_rebounds), fos);
		write(String.valueOf(p.stats_assists), fos);
		write(String.valueOf(p.confidence), fos);
		write(String.valueOf(p.energy), fos);
		write(String.valueOf(p.special_abilities), fos);
		write(String.valueOf(p.special_status), fos);
		write(String.valueOf(p.special_duration), fos);
		

	}
	private static void saveLeague(League l, FileOutputStream fos) throws Exception{
		write(l.league_name, fos);
		write(String.valueOf(l.number_of_meetings), fos);
		write(String.valueOf(l.playoff_teams_par_conference), fos);
		write(String.valueOf(l.season), fos);
		write(String.valueOf(l.conference_numbers), fos);
		for (int i=0;i<l.conference_numbers;i++) {
			write(l.conference_names[i], fos);
		}
		write(String.valueOf(l.teams_conference.length), fos);
		for (int i=0;i<l.teams_conference.length;i++) {
			write(String.valueOf(l.teams_conference[i]), fos);
		}
		write(String.valueOf(l.free_agents.length), fos);
		for (int i=0;i<l.free_agents.length;i++) {
			savePlayer(l.free_agents[i], fos);
			
		}
		
		write(String.valueOf(l.best_of_x_in_playoffs), fos);
		write(String.valueOf(l.play_other_conferences_in_rs), fos);
		

		for (int i=0;i<l.number_of_meetings;i++) {
			for (int j=0;j<l.teams_conference.length;j++){
				for (int k = j+1;k<l.teams_conference.length;k++) {
					write(String.valueOf(l.games[i][j][k].day), fos);
				}
			}
		}
		
		
		
		
		
	}
	private static void write(String v, FileOutputStream fos) throws IOException {
		char[] b = v.toCharArray();
		for (int j=0;j<b.length;j++){
			if (b[j] == '|' && b[j] == '') b[j] = '_'; 
			fos.write(b[j]);	
		}
		fos.write('|');
	}

	public static Game load(File file){
		Game game = new Game();
		try {
			FileInputStream fis = new FileInputStream(file);
			byte version = (byte)fis.read();
			game.season = Integer.parseInt((read(fis)));
			game.day = Integer.parseInt((read(fis)));
			game.matchonday = Integer.parseInt((read(fis)));
			game.season_phase = Integer.parseInt(read(fis));
			game.po_round = Integer.parseInt(read(fis));
			
			game.team = loadTeam(fis);
			int numberofteams = Integer.parseInt(read(fis));
			game.opponents = new Team[numberofteams];
			for (int i=0;i<numberofteams;i++) {
				game.opponents[i] = loadTeam(fis);
			}
			game.league=loadLeague(fis);

			fis.close();
			
		} catch (Exception ex) {System.err.println("----"+ex.getMessage());
						ex.printStackTrace();}
		return game;
	}
	private static Team loadTeam(FileInputStream fis) throws IOException{
		Team team = new Team();
		team.name = read(fis);
		team.games_won = Integer.parseInt(read(fis));
		team.games_lost = Integer.parseInt(read(fis));
		team.deadsalary = Integer.parseInt(read(fis));
		team.credits = Integer.parseInt(read(fis));
		team.score = Integer.parseInt(read(fis));
		
		team.draftpicks=new int[Integer.parseInt(read(fis))];
		for (int i=0;i<team.draftpicks.length;i++) {
			team.draftpicks[i] = Integer.parseInt(read(fis));
		}
		team.futuredraftpicks = new DraftPick[Integer.parseInt(read(fis))];
		for (int i=0;i<team.futuredraftpicks.length;i++) { 
			int y = Integer.parseInt(read(fis));
			int r =Integer.parseInt(read(fis));
			int t = Integer.parseInt(read(fis));
			team.futuredraftpicks[i] = new DraftPick(y,r,t);
		}

		for (int i =0;i<15;i++) {
			
			team.players[i] = loadPlayer(fis);
		
		}
		
		return team;
	}
	
	private static Player loadPlayer(FileInputStream fis) throws IOException {
		Player p=new Player();
		p.lastname = read(fis);
		p.firstname= read(fis);
		p.position = Integer.parseInt(read(fis));
		p.age = Integer.parseInt(read(fis));
		p.seasons = Integer.parseInt(read(fis));
		p.seasons_left_contract = Integer.parseInt(read(fis));
		p.annual_salary = Integer.parseInt(read(fis));
		
		p.skill_scoring = Integer.parseInt(read(fis));
		p.skill_passing = Integer.parseInt(read(fis));
		p.skill_rebounds = Integer.parseInt(read(fis));
		p.skill_defense = Integer.parseInt(read(fis));
		p.stats_games = Integer.parseInt(read(fis));
		p.stats_points = Integer.parseInt(read(fis));
		p.stats_rebounds = Integer.parseInt(read(fis));
		p.stats_assists = Integer.parseInt(read(fis));
		p.confidence = Integer.parseInt(read(fis));
		p.energy = Integer.parseInt(read(fis));
		p.special_abilities = Integer.parseInt(read(fis));
		p.special_status = Integer.parseInt(read(fis));
		p.special_duration = Integer.parseInt(read(fis));
		
		return p;
	}
	
	private static League loadLeague(FileInputStream fis) throws IOException {
		
		League l = new League();
		l.league_name = read(fis);
		l.number_of_meetings = Integer.parseInt(read(fis));
		l.playoff_teams_par_conference = Integer.parseInt(read(fis));
		l.season= Integer.parseInt(read(fis));
		int length = Integer.parseInt(read(fis));
		l.conference_numbers=length;
		l.conference_names = new String[length];
		for (int i=0;i<length;i++) {
			l.conference_names[i] = read(fis);
		}
		length = Integer.parseInt(read(fis));
		l.teams_conference = new int[length];
		for (int i=0;i<length;i++) {
			l.teams_conference[i] = Integer.parseInt(read(fis));
		}
		l.free_agents = new Player[Integer.parseInt(read(fis))];
		for (int  i=0;i<l.free_agents.length;i++) {
			l.free_agents[i] = loadPlayer(fis);
		}
		l.best_of_x_in_playoffs =  Integer.parseInt(read(fis));
		l.play_other_conferences_in_rs=Boolean.parseBoolean(read(fis));
		

		l.games = new GameDate[l.number_of_meetings][l.teams_conference.length][l.teams_conference.length];


		for (int i=0;i<l.number_of_meetings;i++) {
			for (int j=0;j<l.teams_conference.length;j++){
				for (int k = j+1;k<l.teams_conference.length;k++) {
					int v = Integer.parseInt(read(fis));
					l.games[i][j][k] = new GameDate(v, j, k);

				}
			}

		}

		return l;
	}
	
	
	
	
	public static String read(FileInputStream fis) throws IOException {
		String str = new String();
		char b = (char)fis.read();
		while (b != '|'){
			str += b;
			b=(char)fis.read();
		}
		return str;
			
	}
	
	public static Game generate(League league, int choice) {
		Game g = new Game();
		int[] tmparray = new int[league.teams_conference.length];
		for (int i=0;i< tmparray.length;i++) {
			tmparray [i] =league.teams_conference[i];
		}
		league.teams_conference[0] = league.teams_conference[choice];
		
		
		
		g.league = league;
		for (int i=0;i<g.league.teams.length;i++) {
			for (int j=0;j<15;j++) {
				g.league.teams[i].players[j].randomContract();
			}
		}
		g.team=league.teams[choice];
		g.team.score=0;
		g.team.credits = 3000*g.team.freeSpots() + 5000;
		g.opponents = new Team[league.teams.length-1];

		int i =0;
		while (i<g.opponents.length){
			
			if (i< choice)  {
				g.opponents[i] = g.league.teams[i]; 
				g.league.teams_conference[i+1] = tmparray[i];
				
			}
			if (i >= choice )g.opponents[i] = g.league.teams[i+1];
			i++;
			
		}
		g.day = 0;
		g.season=1;
		g.matchonday=0;
		g.league.generateSchedule();
		g.league.generateFA(35, 5);
		g.po_round = 0;		
		return g;
	}
	
	
	public static Object[] allPlayers(GameMain main){
		Object[] p = Func.join(main.team.players,main.league.free_agents );
		
		for (int i=0;i<main.opponents.length;i++){
			
			Object[] p2=Func.join(p,main.opponents[i].players);
			p=p2.clone();
		}
		return p;
	}
}
