package main;
import dialogs.*;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.List;

import javax.swing.JOptionPane;
public class League {
	private static int days = 60*60*24*1000;
	public static int DAYS_RS = 4*30+18;
	public String[] conference_names = {"Eastern Conference", "Western Conference"};
	public int conference_numbers=2;
	public String league_name = "NBA";
	public int[] teams_conference;
	public int playoff_teams_par_conference = 2;
	public int number_of_meetings = 4;
	public int best_of_x_in_playoffs= 4;
	public boolean play_other_conferences_in_rs = true;
	public String filename;
	public GameDate[][][] games;
	public Player[] free_agents;
	public int season =1;
	public Team[] teams = new Team[0];
	private int m;
	public League() {
		
	}


	public List<GameDate> getAllGamesonDayX(int dayx) {
		List<GameDate> g = new ArrayList<GameDate>();
		m=teams_conference.length;
		for (int i=0;i<number_of_meetings;i++){

			for (int j=0;j<m;j++) {
				for (int k=j+1;k<m;k++) {
					if (games[i][j][k]!=null) {
						if (games[i][j][k].day == dayx){
							g.add(games[i][j][k]);
						}
					}
				}
			}
		}
		return g;

	}


	public void generateSchedule() {
		boolean po=play_other_conferences_in_rs;
		int n = number_of_meetings;
		m = teams_conference.length;
		
		Date date = new Date(2006+season, 11, 1);
		long startdate = date.getTime();
		games = new GameDate[n][m][m];
		int numberofdays = DAYS_RS;

		for (int i=0;i<n;i++) {
			for (int j=0;j<m;j++) {
				for (int k=j+1;k<m;k++) {
					if (po || teams_conference[j]==teams_conference[k]) {
						int rndday = (int)(Math.random()*numberofdays);
						GameDate gm = new GameDate(rndday, j,k);
						games[i][j][k]=gm;
					}
					else games[i][j][k] = new GameDate(-1, j, k);
				}
			}
				
		}
			
		
	}
	public void generateFA(int number, int maxskill) {
		free_agents = new Player[number];
		for (int i=0;i<number;i++) {
			free_agents[i] = Player.randomPlayer(maxskill);
			free_agents[i].age = free_agents[i].age + (int)(Math.random()*18);
			if (free_agents[i].age < 22) free_agents[i].seasons=0;
			else free_agents[i].seasons = free_agents[i].age-21;
		}
	}
	public void removeFA(int id) {
		Player[] fatmp=new Player[free_agents.length-1];
		
		for (int i=0;i<fatmp.length;i++) {
			if (i<id) fatmp[i] = free_agents[i];
			else fatmp[i]=free_agents[i+1];
		}
		free_agents = fatmp;
	}
	public void addFA(Player p) {
		Player[] fatmp=new Player[free_agents.length+1];
		
		for (int i=0;i<fatmp.length-1;i++) {
			fatmp[i] = free_agents[i];
			
		}
		fatmp[fatmp.length-1] = p;
		free_agents = fatmp;
	}
	public static void generatePlayoffs(GameMain main) {
		main.date = new Date(2007+main.season, 6, 15);
		int n= main.league.conference_numbers;
		int m = main.league.teams_conference.length;
		int p =main.league.playoff_teams_par_conference;
		main.league.games = new GameDate[main.league.number_of_meetings][m][m];
		
		// "-1" as default value: no team
		for (int i=0;i<main.league.number_of_meetings;i++) {
			for (int j=0;j<m;j++) {
				for (int k=j+1;k<m;k++) {
					int t1=Math.min(j, k);
					int t2=Math.max(j,k);
					GameDate gm = new GameDate(-1,t1, t2);
					main.league.games[i][t1][t2]=gm;
				}
			}
		}
		List[] division_standings = new List[n];
		for (int i=0; i<n;i++) {
			int counter=0;
			int k=0;
			for (int j=0; j<m;j++) {
				if (main.league.teams_conference[j]==i) counter++;
			}
			Object[] data = new Team[counter];
			
			for (int j=0;j<counter;j++){
				
				while (true) {
					if (main.league.teams_conference[k]==i) {
						if (k ==0) data[j] = main.team; 
						else data[j] = main.opponents[k-1];
						k++;
						break;
					}
					k++;
				}
				
			}
			List list = Arrays.asList(data);


			Collections.sort(list);
			division_standings[i] = list;
			for (int j1 =0;j1<p/2;j1++){
				int team1_id=-1;
				int team2_id =-1;
				Team team1 = (Team)list.get(j1);
				Team team2 = (Team)list.get(p-1-j1);
				// add points for score:
				team1.score += 10;
				team2.score += 10;
				
				if (team1 == main.team) team1_id = 0;
				if (team2 == main.team) team2_id = 0;
				
				//for exact calculation of position:
				int pos_tmp = j1; 
				if ( main.league.playoff_teams_par_conference ==8) {
					if (j1 == 1 ) pos_tmp = 2;
					if (j1 == 2) pos_tmp = 3;
					if (j1 == 3) pos_tmp = 1;
				}
				int position = (i*(main.league.playoff_teams_par_conference/2))+pos_tmp;
				for (int j2 =0;j2<m-1;j2++) {
					if (team1 == main.opponents[j2]) team1_id = j2+1;
					if (team2 == main.opponents[j2]) team2_id = j2+1;
				}
				
				if (team1_id>-1 && team2_id>-1) {
					int t1 = Math.min(team1_id, team2_id);
					int t2 = Math.max(team1_id, team2_id);
					
					// [0][t1][t2] --> round*100 + position;
					main.league.games[0][t1][t2] = new GameDate(1*100 + position,t1, t2);

				}
			
			}
		}
	}
	public static void newSeason (GameMain main) {
		main.matchonday = 0;
		main.season_phase = Game.SEASON_OFFSEASON;
		main.po_round = 0;
		main.season ++;
		main.league.generateSchedule();
		main.team.resetStats();
		main.team.credits += 80000;
		
		String expiring="The following players have an expiring deal:\n";
		for (int i=0;i<15;i++) {
			Player p =main.team.players[i];
			if (p.real()) {
				p.age++;
				p.energy = 15;
				p.seasons++;
				p.seasons_left_contract--;
				if (p.seasons_left_contract <=0) {
					expiring +="\n - "+p.firstname+" "+p.lastname;
				}
			}
		}
		String text = main.team.ageEffectText();
		JOptionPane.showMessageDialog(main, text);
		
		expiring +="\n Now is the last chance to re-sign them before the \n start of next season";
		JOptionPane.showMessageDialog(main, expiring);
		
		main.date = new Date(2006+main.season, 9, 20);
		for (int i = 0;i< main.opponents.length;i++) {
			Team t =main.opponents[i];
			t.resetStats();
			t.credits +=20000;
			t.ageEffectText();
			for (int j=0;j<15;j++) {
				Player p= t.players[j];
				if (p.real()) {
					p.age++;
									
					p.seasons++;
					p.seasons_left_contract--;
					if (p.seasons_left_contract <=0) {
						if (t.credits > p.calculateSalary()) {
							int rnd = (int)(Math.random()*3);
							if (rnd != 0) {
								p.seasons_left_contract=1;
								t.credits-=p.calculateSalary();
							}
						}
					}
				}
			}
			t.optimizeRoster();
			
			
		}
		for (int j=0;j<main.league.free_agents.length;j++) {
			Player p= main.league.free_agents[j];
			if (p.real()) {
				p.age++;
								
				p.seasons++;
				p.seasons_left_contract--;
				
			}
		}
		
	}
	
	public static void startSeason(GameMain main) {
		League.expiringRelease(main);
		League.signFA(main);
		int len = main.league.free_agents.length;
		if (len > 90) {
			Player [] orderedfa =  main.league.free_agents.clone();
			QuickSort.quicksort(orderedfa, QuickSort.YRS);
			Player[] newfa = new Player [90];
			for (int i=0;i<90;i++) {
				newfa[i] = orderedfa[len-90+i];
			}
			main.league.free_agents = newfa;
		}
		main.season_phase = Game.SEASON_REGULAR;
		main.day = 0;
		main.matchonday=0;
		main.nextGame();
		
	}
	public static void expiringRelease(GameMain main) {

		for (int i=0;i<15;i++) {
			Player p = main.team.players[i];
			if (p.real() && p.seasons_left_contract < 1) {
				if (p.age<32) main.league.addFA(p);
				main.team.players[i] = new Player();
			}
		}
		
		for (int j=0;j<main.opponents.length;j++) {
			Team t = main.opponents[j];
			for (int i=0;i<15;i++) {
				Player p = t.players[i];
				if (p.real() && p.seasons_left_contract < 1) {
					if (p.age<32) main.league.addFA(p);
					t.players[i] = new Player();
					
				}
			}
			t.optimizeRoster();
		}
	}
	public static void signFA(GameMain main) {

	
		for (int j=0;j<main.opponents.length;j++) {
			Team t = main.opponents[j];

			int search =0;
		
			for (int i =0;i<5;i++) {
				
				if (t.players[i].position != i+1) search =i+1;
				else if (t.players[i+5].position != i+1) search =i+1;
			}
			Player[] fa = main.league.free_agents;
			QuickSort.quicksort(fa, QuickSort.SALARY);
			for (int i=0;i<fa.length;i++) {
				if (fa[i].calculateSalary()<=t.credits &&
						(search ==0 || search == fa[i].position)) {
					t.findRosterSpot(fa[i], main.league);
					fa[i].seasons_left_contract = 1;
					t.credits = t.credits - fa[i].calculateSalary();
					main.league.removeFA(i);
					break;
				}
			}

			t.optimizeRoster();
		}
	}
	public static void nextRound (GameMain main) {
		if (main.season_phase == Game.SEASON_FINALS){
			for (int i=0; i<main.opponents.length+1;i++) {
				for (int j=i+1; j<main.opponents.length+1;j++) {
					Team team1;
					Team team2;
					if (main.league.games[0][i][j].day / (100) == (main.po_round)) {
						if (i==0) team1 = main.team;
						else team1 = main.opponents[i-1];
						team2 = main.opponents[j-1];
						while (team1.games_won < main.league.best_of_x_in_playoffs && team2.games_won < main.league.best_of_x_in_playoffs) {
							BoxScore boxscore = new BoxScore(team1,team2, true);
							boxscore.updateStats();
							main.day+=2;
						}
						
						if (team1.games_won == main.league.best_of_x_in_playoffs) team1.score += 100;
						else team2.score += 100;
							
							
						
					}
				}
			}
			
			main.season_phase = Game.SEASON_AFTER_PO;
		}
		else {
			int round = main.po_round +1;
			main.po_round = round;
			int teamsleft;
			
			teamsleft = (main.league.conference_numbers*main.league.playoff_teams_par_conference)/(int)Math.pow(2, round-1);
		
			if (teamsleft ==2) {main.season_phase = Game.SEASON_FINALS;}
			int[] winners = new int[teamsleft];
			for (int i=0; i<main.opponents.length+1;i++) {
				for (int j=i+1; j<main.opponents.length+1;j++) {
					Team team1;
					Team team2;
					if (main.league.games[0][i][j].day / (100) == (round-1)) {
						if (i==0) team1 = main.team;
						else team1 = main.opponents[i-1];
						team2 = main.opponents[j-1];
						while (team1.games_won < main.league.best_of_x_in_playoffs && team2.games_won < main.league.best_of_x_in_playoffs) {
							BoxScore boxscore = new BoxScore(team1,team2, true);
							boxscore.updateStats();
							main.day++;
						}
						
						int po_position = Func.mod(main.league.games[0][i][j].day, 100);
						if (team1.games_won >team2.games_won) {
							winners[po_position] = i; 
							team1.score +=20;
						}					
						else {
							winners[po_position] = j; 
							team2.score+=20;
						}					
						
						team1.games_lost =0;
						team1.games_won = 0;
						team2.games_lost =0;
						team2.games_won = 0;
	
					}
				}
			}
			for (int i =0;i<winners.length/2;i++) {
				int t1 = winners[2*i];
				int t2 = winners[2*i+1];
				if (t1>t2) {
					int tmp = t2;
					t2 = t1;
					t1 = tmp;
				}
				main.league.games[0][t1][t2] = new GameDate(round*100+ i, t1, t2);
			}
		}
	}
	

	public static void writeLeague(File f, League l) {

		try {
			FileOutputStream fos = new FileOutputStream(f);
			write(l.league_name, fos);
			write(String.valueOf(l.conference_numbers), fos);
			for (int i=0;i<l.conference_numbers;i++) {
				write(l.conference_names[i], fos);
			}
			
			write(String.valueOf(l.play_other_conferences_in_rs), fos);
			write(String.valueOf(l.number_of_meetings), fos);
			write(String.valueOf(l.playoff_teams_par_conference), fos);
			write(String.valueOf(l.teams.length), fos);
			for (int i =0;i<l.teams.length;i++) {
				write(l.teams[i].filename, fos);
			}
			for (int i =0;i<l.teams_conference.length;i++) {
				write(String.valueOf(l.teams_conference[i]), fos);
			}
			write(String.valueOf(l.best_of_x_in_playoffs), fos);
		} catch (Exception ex) {}
	}
	public static League readLeague(File f) {
		League l = new League();
		try {
			FileInputStream fis= new FileInputStream(f);
			l.filename = f.getName();
			if (l.filename.endsWith(".pb08")) l.filename=l.filename.substring(0, l.filename.length()-5);
			l.league_name = read(fis);
			l.conference_numbers = Integer.parseInt(read(fis));
			l.conference_names = new String[l.conference_numbers];

			for (int i=0;i<l.conference_numbers;i++) {
				l.conference_names[i] = read(fis);
			}
			l.play_other_conferences_in_rs = Boolean.parseBoolean(read(fis));
			l.number_of_meetings = Integer.parseInt(read(fis));
			
			l.playoff_teams_par_conference = Integer.parseInt(read(fis));
			l.teams = new Team[Integer.parseInt(read(fis))];
			for (int i=0;i<l.teams.length;i++) {
				String nameoffile = read(fis);
				File file = new File("data/teams/"+nameoffile+".pb08");
				
				l.teams[i] =  Team.fromFile(file);
				
			}
			l.teams_conference = new int[l.teams.length];
			for (int i=0;i<l.teams_conference.length;i++) {
				l.teams_conference[i] = Integer.parseInt(read(fis));
			}
			l.best_of_x_in_playoffs= Integer.parseInt(read(fis));
			
		} catch (Exception ex) {}
		return l;
	}
	public static String read(FileInputStream fis) throws IOException {
		String str = new String();
		char b = (char)fis.read();
		while (b != '|'){
			str += b;
			b=(char)fis.read();
		}
		return str;
			
	}
	private static void write(String v, FileOutputStream fos) throws Exception {
		char[] b = v.toCharArray();
		for (int j=0;j<b.length;j++){
			if (b[j] == '|') b[j] = '_'; 
			fos.write(b[j]);	
		}
		fos.write('|');
	}

}
