package main;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

import dialogs.*;

public class Menu extends JMenuBar{
	JMenu _editor;
	JMenu _game;
	JMenu _help;
	public Menu() {
		super();
		_editor = new JMenu("Editor");
		
		JMenuItem item = new JMenuItem("New Player", 'N');
		item.addActionListener(newplayerlistener);
		_editor.add(item);
		item = new JMenuItem("Edit Player", 'E');
		item.addActionListener(loadplayerlistener);
		_editor.add(item);
		_editor.addSeparator();
		item = new JMenuItem("New Team", 'T');
		item.addActionListener(newteamlistener);
		_editor.add(item);
		item = new JMenuItem("Edit Team", 'M');
		item.addActionListener(loadteamlistener);
		_editor.add(item);
		_editor.addSeparator();
		item = new JMenuItem("New League", 'L');
		item.addActionListener(newleaguelistener);
		_editor.add(item);
		item = new JMenuItem("Edit League", 'U');
		item.addActionListener(loadleaguelistener);
		_editor.add(item);
		this.add(_editor);
		_game = new JMenu("Game");
		item = new JMenuItem("New Game", 'G');
		item.addActionListener(newgamelistener);
		_game.add(item);
		item = new JMenuItem("Load Game", 'L');
		item.addActionListener(gameloadlistener);
		_game.add(item);
		this.add(_game);
		
		_help = new JMenu("Misc");
		item = new JMenuItem("Hall of Fame", 'H');
		item.addActionListener(hofListener);
		_help.add(item);
		add(_help);
		
		
	}
	ActionListener newplayerlistener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			PlayerDialog npd = new PlayerDialog();
			
		}
	};
	ActionListener loadplayerlistener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			JFileChooser chooser = new JFileChooser("data/players/");
			
			int returnVal = chooser.showOpenDialog(null);			
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				
				
				File file = chooser.getSelectedFile();
				PlayerDialog npd = new PlayerDialog(Player.readPlayer(file), file.getName());
			}
		}
	};
	ActionListener newteamlistener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			TeamDialog tpd = new TeamDialog();
			
		}
	};
	ActionListener loadteamlistener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			JFileChooser chooser = new JFileChooser("data/teams/");
			int returnVal = chooser.showOpenDialog(null);			
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				File file = chooser.getSelectedFile();
				TeamDialog ntd = new TeamDialog(Team.fromFile(file));
			}
		}
	};
	ActionListener newleaguelistener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			LeagueDialog ld = new LeagueDialog();
			
		}
	};
	ActionListener loadleaguelistener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			JFileChooser chooser = new JFileChooser("data/leagues/");
			int returnVal = chooser.showOpenDialog(null);			
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				File file = chooser.getSelectedFile();
				LeagueDialog ntd = new LeagueDialog(League.readLeague(file));
			}
		}
	};
	ActionListener newgamelistener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			JFileChooser chooser = new JFileChooser("data/leagues/");
			chooser.setDialogTitle("Select a league to play in");
			int returnVal = chooser.showOpenDialog(null);			
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				File file = chooser.getSelectedFile();
				League l = League.readLeague(file);
				TeamChooser tc = new TeamChooser(l);
				
			}
		}
	};
	ActionListener gameloadlistener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			JFileChooser chooser = new JFileChooser("data/savegames/");
			
			int returnVal = chooser.showOpenDialog(null);
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				File file = chooser.getSelectedFile();
				Game game = Game.load(file);
				GameMain gm = new GameMain(game);
				
			}
		}
	};
	ActionListener hofListener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			
			HighScore.displayHighScore();
		}
	};
}

