package main;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public class Player implements Comparable {
	public int compareTo(Object o2) {
		int s1 = this.overallValue();
		int s2 = ((Player)o2).overallValue();
		return (s2-s1);
	}
	public String firstname;
	public String lastname;
	public int position = 0;
	public int age;
	public int seasons;
	public int seasons_left_contract;
	public int annual_salary;
	
	public int skill_scoring;
	public int skill_passing;
	public int skill_rebounds;
	public int skill_defense;
	
	public int stats_points;
	public int stats_rebounds;
	public int stats_assists;
	public int stats_games;
	
	public int special_abilities;
	public int special_status=0;
	public int special_duration = 0;
	
	public int energy;
	public int confidence;

	public Player() {
		firstname="";
		lastname="";
		energy = 15;
		confidence = 12;
		position = 0;
	}

	public boolean real() {
		if (position==0) {
			return false;
		}
		else return true;
	}
	
	
	public static void writePlayer(File f, Player p) {

		try {
			FileOutputStream fos = new FileOutputStream(f);
			write(p.lastname, fos);
			write(p.firstname, fos);
			write(String.valueOf(p.position), fos);
			write(String.valueOf(p.age), fos);
			write(String.valueOf(p.seasons), fos);
			write(String.valueOf(p.seasons_left_contract), fos);
			write(String.valueOf(p.annual_salary), fos);			
			write(String.valueOf(p.skill_scoring), fos);
			write(String.valueOf(p.skill_passing), fos);
			write(String.valueOf(p.skill_rebounds), fos);
			write(String.valueOf(p.skill_defense), fos);

			write(String.valueOf(p.special_abilities), fos);
		} catch (Exception ex) {}
		
	}
	public static Player readPlayer(File f) {
		Player p = new Player();
		try {
			FileInputStream fis= new FileInputStream(f);
			p.lastname = read(fis);
			p.firstname= read(fis);
			String lala = read(fis);
			p.position = Integer.parseInt(lala);
		
			p.age = Integer.parseInt(read(fis));
			p.seasons = Integer.parseInt(read(fis));
			p.seasons_left_contract = Integer.parseInt(read(fis));
			p.annual_salary = Integer.parseInt(read(fis));
			p.skill_scoring = Integer.parseInt(read(fis));
			p.skill_passing = Integer.parseInt(read(fis));
			p.skill_rebounds = Integer.parseInt(read(fis));
			p.skill_defense = Integer.parseInt(read(fis));
			p.special_abilities = Integer.parseInt(read(fis));
		} catch (Exception ex) {}
		return p;
	}
	public static String read(FileInputStream fis) throws IOException {
		String str = new String();
		char b = (char)fis.read();
		while (b != '|'){
			str += b;
			b=(char)fis.read();
		}
		return str;
			
	}
	private static void write(String v, FileOutputStream fos) throws Exception {
		char[] b = v.toCharArray();
		for (int j=0;j<b.length;j++){
			if (b[j] == '|') b[j] = '_'; 
			fos.write(b[j]);	
		}
		fos.write('|');
	}
	
	public void resetStats() {
		stats_points=0;
		stats_rebounds = 0;
		stats_assists = 0;
		stats_games = 0;
		if (!real()) {
			energy=0;
			confidence=0;
		}
	}
	public static Player randomPlayer() {
		return randomPlayer(7);
	}
	
	public static Player randomPlayer(int max) {
		Player p = new Player();
		p.firstname = FIRSTNAMES[((int)(Math.random()*FIRSTNAMES.length-1))];
		p.lastname = LASTNAMES[((int)(Math.random()*LASTNAMES.length-1))];
		p.position = (int)(Math.random()*5)+1;
		if (p.position >5) p.position=5;
		
		p.age = 19 + (int)(Math.random()*6);
		p.seasons = -1;
		p.seasons_left_contract = 4;
		
		p.skill_scoring= (int)(Math.random()*max)+1;
		p.skill_passing= (int)(Math.random()*max)+1;
		p.skill_rebounds= (int)(Math.random()*max)+1;
		p.skill_defense= (int)(Math.random()*max)+1;
		
		p.annual_salary = 0;
		
		p.stats_points=0;
		p.stats_rebounds=0;
		p.stats_assists=0;
		p.stats_games=0;
		p.energy = 15;
		p.confidence = 12;
		p.special_abilities =0;
		return p;
	}
	
	private static String[] FIRSTNAMES = {"Hassan", "Abraham", "Paul", "Simon", "Matthias",
		"Fred", "Joe", "Jack","Anderson", "Kim", "Yu", "Stephon", "William", "Andre", 
		"Tim", "Tom", "Chris", "Christian", "Till", "Sven", "Emeka", "Steve", "Doc", 
		"P.G.", "F.P.", "George", "Bill", "Viktor", "Joseph", "Jesus", "Walter", "Cheik",
		"Tristan", "Oskar", "Thomas", "LeBron", "Curtis", "Jason", "Marco", "Darko", 
		"Xavier", "Yi", "Mohammed", "Sergey", "Ivan", "Luca", "Luther", "Ole", "Ming", 
		"Jorge", "Ekrem", "Erkan", "Igor", "Antoine", "Tony", "Gilbert", "Adam", "Jacob",
		"Mike", "Josh", "Ethan", "Matthew", "Daniel", "Andrew", "Anthony", "Alex",
		"David", "Ryan", "Noah", "James", "Nick", "John", "Nathan", "Ben", "Sam",
		"Dylan", "Gabriel", "Elias", "Jose", "Zach", "Caleb", "Mason", "Robert", "Jordan",
		"Justin", "Luke", "Jabba the", "Isaac", "Isaiah", "Austin", "Kevin", "Owen", 
		"Louis", "Diego", "Didier", "Jerome", "Charles", "Sebastian", "Brian", "Sean",
		"Carlos", "Julian", "Miguel", "Henry", "Blake", "Devin", "Richard", "Jean", "Fritz",
		"O.G.", "Hero", "Andreas", "Ullrich", "Gregor", "Radoslav", "Xi", "Air", "Premo", 
		"Quentin", "Franz", "Gerald", "Peter", "Pete", "Lucas", "Nico", "Abdul", "Akeem",
		"Kamil", "Deniz", "Emanuel", "Pimp", "Utah", "Vick", "Osama", "Oleg", "DJ", "MC", 
		"Roger","Allen", "CJ", "Emlyn", "Stefan", "Ilja", "Trevor", "Norman", "Orlando", 
		"Sahin", "Shahin", "Samy", "Otis", "Kurt", "Mitch",
		
		"Jamais"
	};
	
	private static String[] LASTNAMES = {"Miller", "Muller", "Johnson", "Fernndez", 
		"Rodrguez","Gonzlez","Garca","Lpez","Martnez","Prez","lvarez","Gmez",
		"Sanchez", "Li","Smith","Lam","Martin","Brown","Roy","Tremblay","Lee",
		"Gagnon","Wilson","Clark","Johnson","White","Williams","Ct","Taylor",
		"Campbell","Anderson","Chan","Jones" , "Li", "Wang", "Liu", "Chen", "Yang", 
		"Huang", "Zhao", "Zhou", "Xu", "Sun", "Guo", "Novak", "Cerny", "Nemec", "Pokornky", 
		"Kral", "Benes", "Nielson", "Rasmussen","Olsen", "Tammm", "Saar","Korhonen",
		"Martin", "Bernard", "Dubois", "Thomas", "Robert", "Richard", "Petit", "LeRoy", 
		"Schmidt", "Meyer", "Weber", "Schulz", "Schneider", "Fischer", "Szabo", "Murphy", 
		"Kelly", "Cohen", "Levi", "Rossi", "Ferrari", "Bianchi", "Romano", "Ricci", "Colombo",
		"Sato", "Takahashi", "Yoshida", "Matsumoto", "Kimara", "Kim", "Lee", "Han", "Park",
		"Borg", "De Vries", "De Jong", "Bakker", "Johansen", "Andresen", "Villacorta",
		"Kowalksi", "Petrov", "Egorov", "Ivanov", "Li", "Goh","Yilmaz", "Jones", "Williams",
		"Taylor", "Brown", "White", "Grey", "Black", "Evans", "Wilson", "Thompson", "Wright", 
		"Edwards", "Hughes", "Green", "Lewis", "Clark", "Harris", "Jackson", "Hall", "Roberts",
		"Walker", "Robinson", "McDonald", "O'Neal", "Campbell", "Steward", "Henderson", "Duncan",
		"Graham", "Young", "Morrison", "Peterson", "Murray", "Watson", "Ferguson", "Hamilton", 
		"Scott", "Reid", "Baker", "Adams", "Nelson", "King", "Knight", "Parker", "Collins", "Cool", 
		"Tuner", "Turner", "Mitchell", "Hill", "Junior", "Carter", "Nguyen", "Pham", "Boumtje", "Ndyaie", 
		"Makumba", "Big", "Jordan", "Dunleavy", "Bryant", "Pit", "Herbert", "Fisher", "Goldstein", 
		"Jefferson", "Stalin", "Bush", "Clinton", "Merkel", "Schrder", "Mitterand", "Tito", 
		"Hillton", "Zeiger", "Oliveira", "Barillo", "Sarkozy", "Williamson", "Michaelson", "Wilson", 
		"Fuchs", "Wouters", "Maas", "lvares", "Amaral", "Andrade", "Bernades", "Branco", "Cardoso", 
		"Cordoba", "Camara", "Dias", "Cruz", "Castro", "Costa", "Fagundes", "Nascimento", "Menezes", 
		"Mata", "Neves", "Lima", "Tavares", "Serrano", "Reis", "S", "Silva", "Silver", "Gold", "Torres",
		"Petrauskas", "Berzins", "Kalnins", "Stankevicious", "Jankauskas", "Vasiliauskas", "Zukauskas", 
		"Paulauskas", "Urbonas", "Galea", "Caesar", "Stankovic", "Paulovic", "Darkovic", "Petrovic",
		"Love", "Singh", "Song", "Hamburg", "George", "Driver", "Kong", "Jong", "Allen",
		"Best", "Smart", "Hard", "LeBlanc", "Sousa", "Perovic", "Natureboy",
		"Never"
	};
 
	/**
	 * @return
	 */
	public int overallValue() {
		if (special_status != 0) return 0;
		if (position == 1) {
			return ((30-age)*10)+(skill_scoring*100) + (skill_passing*200) + (skill_rebounds*60) +(skill_defense*100);
		}
		else if (position == 2) {
			return ((30-age)*10)+(skill_scoring*120) + (skill_passing*120) + (skill_rebounds*80) +(skill_defense*120);
		}
		else if (position == 3) {
			return ((30-age)*10)+(skill_scoring*120) + (skill_passing*100) + (skill_rebounds*90) +(skill_defense*120);
		}
		else if (position == 4) {
			return ((30-age)*10)+(skill_scoring*100) + (skill_passing*70)+ (skill_rebounds*150) +(skill_defense*100);
		}
		else {
			return ((30-age)*10)+(skill_scoring*100) + (skill_passing*50) + (skill_rebounds*160) +(skill_defense*100);
		}
		
	}
	
	public int calculateSalary() {
		if (real())annual_salary = (skill_scoring*skill_scoring+skill_passing*skill_passing+skill_defense*skill_defense+skill_rebounds*skill_rebounds +
				(int)Math.pow(skill_scoring+skill_passing+skill_rebounds+skill_defense, 2))*10;
		if (real()) return annual_salary;
		else return 0;
	}
	public void randomContract() {
		if (real()) seasons_left_contract = (int)(Math.random()*6)+1;
		calculateSalary();
	}
	
	public String ageEffectText() {
		
		String str = "\n "+firstname+" "+lastname+" ("+age+") :";
		if (real()) {

			if (age > 29 && seasons != 0) {
				int factor =10;
				
				if (age > 34) factor = 5;
				if (age>37) factor =3;
					int rnd = (int)(Math.random()*factor);
					if (rnd==0 && skill_scoring>1) {
						skill_scoring--;
						str+=" scoring -1  ";
					}
					rnd = (int)(Math.random()*factor);
					if (rnd ==0 && skill_passing>1) {
						skill_passing--;
						str+= " passing -1  ";
					}
					rnd = (int)(Math.random()*factor);
					if (rnd ==0 && skill_rebounds>1) {
						skill_rebounds--;
						str+= " rebounds -1  ";
					}
					rnd = (int)(Math.random()*factor);
					if (rnd ==0 && skill_defense>1) {
						skill_defense--;
						str+= " defense -1  ";
					
					}
			}
			else if (seasons<6 && seasons!=0) {
				int factor =10;
				
				if (seasons<3) factor = 5;
					int rnd = (int)(Math.random()*factor);
					if (rnd==0 && skill_scoring<10) {
						skill_scoring++;
						str+=" scoring +1  ";
					}
					rnd = (int)(Math.random()*factor);
					if (rnd ==0 && skill_passing<10) {
						skill_passing++;
						str+= " passing +1  ";
					}
					rnd = (int)(Math.random()*factor);
					if (rnd ==0 && skill_rebounds<10) {
						skill_rebounds++;
						str+= " rebounds +1  ";
					}
					rnd = (int)(Math.random()*factor);
					if (rnd ==0 && skill_defense<10) {
						skill_defense++;
						str+= " defense +1  ";
					
					}
			}
			
					
		}
		return str;
	}

	public boolean memberOf(Team t){
		for (int i=0;i<15;i++){
			if (t.players[i]==this) return true;
		}
		return false;
	}
}
