package main;

public class QuickSort {
    private static long comparisons = 0;
    private static long exchanges   = 0;
    
    public static int PPG=1;
    public static int APG=2;
    public static int RPG=3;
    public static int YRS=4;
    public static int SALARY=5;
    public static int NAME=6;
    public static int POS =7;
    public static int YRS2=10;
    
    
    

   /***********************************************************************
    *  Quicksort code from Sedgewick 7.1, 7.2.
    ***********************************************************************/
    public static void quicksort(Object[] a,int arg) {
    	
        shuffle(a);                        // to guard against worst-case
        quicksort(a, 0, a.length - 1,arg);
    }
    public static void quicksort(Object[] a) {
        shuffle(a);                        // to guard against worst-case
        quicksort(a, 0, a.length - 1, 0);
    }
    public static void quicksort(Object[] a, int left, int right,int arg) {
        if (right <= left) return;
        int i = partition(a, left, right,arg);
        quicksort(a, left, i-1,arg);
        quicksort(a, i+1, right,arg);
    }

    private static int partition(Object[] a, int left, int right,int arg) {
        int i = left - 1;
        int j = right;
        while (true) {
            while (less(a[++i], a[right],arg))      // find item on left to swap
                ;                               // a[right] acts as sentinel
            while (less(a[right], a[--j],arg))      // find item on right to swap
                if (j == left) break;           // don't go out-of-bounds
            if (i >= j) break;                  // check if pointers cross
            exch(a, i, j);                      // swap two elements into place
        }
        exch(a, i, right);                      // swap with partition element
        return i;
    }

    // is x < y ?
    private static boolean less(Object x, Object y,int arg) {
        comparisons++;
        if (x instanceof Player && arg==NAME){
        	if (((Player)x).lastname.compareTo(((Player)y).lastname)<0) return true;
        	else return false;
        }
        if (x instanceof Player && arg==PPG){
        	if ((Func.div(((Player)x).stats_points,((Player)x).stats_games)) >(Func.div(((Player)y).stats_points,((Player)y).stats_games))) return true;
        	else return false;
        }
        if (x instanceof Player && arg==APG){
        	if ((Func.div(((Player)x).stats_assists,((Player)x).stats_games)) >(Func.div(((Player)y).stats_assists,((Player)y).stats_games))) return true;
        	else return false;
        }
        if (x instanceof Player && arg==RPG){
        	if ((Func.div(((Player)x).stats_rebounds,((Player)x).stats_games)) >(Func.div(((Player)y).stats_rebounds,((Player)y).stats_games))) return true;
        	else return false;
        }
        if (x instanceof Player && arg==YRS){
        	if (((Player)x).age>((Player)y).age) return true;
        	else return false;
        }
        if (x instanceof Player && arg==YRS2){
        	if (((Player)x).age<((Player)y).age) return true;
        	else return false;
        }
        if (x instanceof Player && arg==SALARY){
        	if (((Player)x).calculateSalary()>((Player)y).calculateSalary()) return true;
        	else return false;
        }
        if (x instanceof Player && arg==POS){
        	if (((Player)x).position<((Player)y).position) return true;
        	else if (((Player)x).lastname.compareTo(((Player)y).lastname)<0 &&
        			((Player)x).position==((Player)y).position) return true;
        	
        	else return false;
        }
        
                
        if (x instanceof Team){
        	if (((Team)x).score>((Team)y).score) return true;
        	else return false;
        }
        
        return true;
    }

    // exchange a[i] and a[j]
    private static void exch(Object[] a, int i, int j) {
        exchanges++;
        Object swap = a[i];
        a[i] = a[j];
        a[j] = swap;
    }

    // shuffle the array a
    private static void shuffle(Object[] a) {
        int N = a.length;
        for (int i = 0; i < N; i++) {
            int r = i + (int) (Math.random() * (N-i));   // between i and N-1
            exch(a, i, r);
        }
    }
}
